## Thanks for using KeyNote NF. You can show your appreciation and support future development by donating!

## Remember to make backups of .knt files. Recommended option: 'Backup at regular intervals'


v 2.1.7.1  (21 mar 2026)
--------------------------
* New: Shift + 'View|Encrypted content' -> highlight encrypted nodes [#985]
* New advanced search token, '*?' -> allows restricting searches/filtering to encrypted nodes [#985]
* Information about tags of the protected nodes is now hidden when the encrypted content is 'closed'
* Improvements and fixes related to advanced search tokens in Find All/Tree filtering
- - -
* Fixed: Incorrect loading of ANSI texts with DBCS encoding in the editor in certain situations [#990]
* Fixed: Double click word to select only the word, without space(s) (It was partially resolved) [#951]


v 2.1.6.1  (08 mar 2026)
--------------------------
* New: The "Lock on opening" option has been added to enable more secure collaborative work [#607]
* New option associated with "Backup at regular intervals": "Max daily backup level"  [#976]
--
* Auto scroll on Tree: Fixed the caption and hint of the existing option [#823]
* Fixed: Allow pasting when entering password / Also: Backspace key ignored  [#969]
* Fixed: When converting hyperlinks to standard bookmarks upon export, most links appear in black
* Fixed: The character used as closing for the folded text (□) is not displayed when exporting
* Fixed: Icon associated with the compressed file format opened in read-only mode


v 2.1.5.3  (19 feb 2026)
--------------------------
Patch for version 2.1.5 (.1):
* Fixed: Exception in the x64 version when using 'Enable encrypted content' [#961]
* Fixed: Exception with ImgAllowEncrExternal=0 and storage mode=EmbeddedKNT [#961]
* Fixed: Problem with ImgAllowEncrExternal=1 and storage mode=External [#961]
* Fixed: Encrypted images and converting image storage mode, from EmbeddedKNT to External, 
         with ImgAllowEncrExternal=0 [#961]


v 2.1.5.2  (19 feb 2026)
--------------------------
* Fixed: Exception with ImgAllowEncrExternal=0 and storage mode=EmbeddedKNT [#961]
* Fixed: Problem with ImgAllowEncrExternal=1 and storage mode=External [#961]
* Fixed: Encrypted images and converting image storage mode, from EmbeddedKNT to External, 
         with ImgAllowEncrExternal=0 [#961]


v 2.1.5.1  (15 feb 2026)
--------------------------
* Added option to encrypt only selected content (nodes and/or images)
* Encryption strengthened, obtaining the key from the password with a configurable number of iterations [#545]
* Added protection against basic/intermediate keyloggers
* Fixed: Password field vulnerable to password reveal tools like BulletsPassView (#599)
--
* Insert|Line and Insert|Table with Shift (=> printable) will use Text color (Format|Text Color,  Ctrl+R) [#944]
* RTF Templates can use 4 tokens to allow some configuration in color || Added several Line/Table templates [#944]
--
* Insert|URL... Use URL in clipboard (#706)
* Double click word to select only the word, without space(s) [#951]
* "Paste External as Plain text" -> "Paste External using 'Plain text mode'"
--
* Fixed: In most situations, it is not possible to change the blue colour of links [#923]
* Added a new command line option: -clnkc  (Convert links to allow for proper text colour management)
* Fixed: Adjustments to the treatment of folded blocks
--
* Fixed: The check-state of a hidden checkbox node is saved, but it is ignored when the file is opened [#947]
* Fixed: Exception using F6 (Defaults for all files) with no file open  [#953]
* Fixed: Avoid possible exception when starting the application [#946]
* Fixed: Crash in W8.1 when opening Font settings dialog [#726][#613]


v 2.1.4.1  (24 dec 2025)
--------------------------
* Fixed: MBCS languages and plain text notes [#936]
* New: Insert | Line
* New: Insert | Table...
* Fixed: Command line option (-clnks) is not converting old (file:///*) links
* Fixed: KNT links in previous format (file:///*) in Merged notes must be converted to new format based on GIDs
* Fixed: Possible exception when moving a node or subtree to another folder (when trying to update the navigation history)
* Fixed: KeyNote NF does not respond...  when pasting in a very specific situation
* Fixed: Enabled state of format toolbar buttons and Insert|Image/Object menu entries when focus is moved to the tree [#885]
* Fixed: Floating editor should be closed when selected another node in the same folder
* Fixed: When unfolding a block with images, these could remain hidden, if it is contiguous with another block or hyperlink


v 2.1.3.1  (10 nov 2025)
--------------------------
* IMPORTANT! - Fixed: It was possible for new nodes to be created with an incorrect RTF/Plain state
--
* Fixed: Text formatting is lost after applying (#920):
  "Compress White Space", "Trim Left", "Trim Right", "Trim Both", "Sort Lines", "Join Lines"
* New: Trim commands and "Compress White Space" can also be repeated (Edit | Repeat) or recorded in a Macro
* New: "Join Lines" can use custom string to join, instead of the default space, allowing (eg.): 'L1', 'L2', ...
--
* Fixed: Spaces at the end (or beginning) of the clipboard capture divider are not preserved in the .ini file (#917 #918)
* Fixed: It is now possible to switch between 'Plain Text' and RTF in empty notes
--
* Find All: Fixed searches using unregistered tags
* Find All: Fixed: Changes in tags (global or applied to a note) while Find All had set WITH or WITHOUT tag criteria
* Find All: Fixed: Consider ALL/ANY mode when using non registered tags from WITH tag criteria
* Fixed: Possible exception in certain (rare) situation when focusing on Find tab in the Resource Panel
--
* Export/Print: The last settings used in page orientation and page margins, are now saved to .ini file (in profile)
* File|Export: Improvements when using 'Consider extracts from notes'
* Fixed exception if editor was showing the tag selector when opening File|Export and entering in With or Without fields


v 2.1.2.1  (19 oct 2025)
--------------------------
* The design of several forms and dialogs has been revised to facilitate translation into other languages.
* Added completed Spanish translation for version 2.1.2
--
* New: When saving the file, the current state of the 'Show or Hide Images' button will also be saved.
* Fixed: When Image/'Single instance'/'Hot track' option is enabled, navigating with keyboard between two hidden 
  and contiguous images doesn't show the image, it is necessary to press left or right
--
* Fixed: Added INI option (FixEmojisProblem) to avoid problem caused by certain Unicode sequences used in Emojis [#896]
* Fixed: Scroll bar position could be lost when focus was returned to KeyNote by clicking in the Editor (#720)
--
* New: Added OPML format to File - Export  (#802)
* Fixed: Export/"Folded Text": "Keep unchanged" is handled as "Unfold" when exporting to "Plain Text", "HTML", or "OPML"


v 2.1.1.1  (08 oct 2025)
--------------------------
* New: Image viewer allows copying images to clipboard (#882)
* Fixed: Possible exception "Failed to Load Stream" working on newly created node, before persisted to the model
* Fixed: Exception when exporting (File|Export...) "Current node" filtering by tags (in metadata or note content)
* Fixed: All possible exceptions that may occur in ApplicationEventsIdle are now discarded.
* Fixed: Tree > Set Focus > "Toggle Focus Editor / Tree Panel" keyboard shortcut. Should display Ctrl+\ (#887)
* Fixed: Hiding a node by checking it doesn't select another node and the editor still displays it.
* Fixed: If Image/Single instance/Hot track option is enabled, often two clicks are required to open the viewer
--
* Find All: You can navigate through search results using Up, Down, Home, End, Prior, Next and Enter keys (#888)
* Fixed: Advanced search: "sentences" can also be separated by exclamation or question marks (¿ ? ¡ !)
* Fixed: Difficulty selecting a search result (in Find All) if it displays special characters.
* Fixed: Searches may not correctly highlight results if images are visible and note contains images inside folded text
--
* New property on Folder: TagSelectorDisabled, to allow disabling the display of the tag selector in the editor (#884)
* Fixed: Exception after removing a temporary added tag (green) if it's visible in tag selector and focus changes
  to tree panel
* Fixed: Register tags added to the end of the editor when the editor loses focus
* Fixed: Hide tag selector when opening a modal window (like Configuration options (F5), Default settings (F6), etc)
* Fixed: Tags registered within folded text (via floating editors) are discarded when returning to the parent editor
* Fixed: Avoided situation that could generate an AccessViolation exception, caused by tag management
--
* Folding/Unfolding can now be used with TABLES (the table structure, with its borders, will also be hidden)
* Folding: New properties in the opening/closing tokens defining folding blocks: [Keep | Discard], Use on expand
* Folding: New RTF context menu command: "Expand (with markers)"
* Folding: Shift + menu commands "Fold", "Expand (with markers)" or "Unfold":  all blocks in a note at once
* Folding: Ignore leading spaces when searching for two consecutive spaces to identify the end of the visible excerpt
* Folding: Improved selection (with Ctrl+Click) of opening token when set before a carriage return 
* Folding: Improved use of very small opening tokens when attached to text to be folded (and Ctrl+Click is used)
* Fixed: Making changes within a floating editor does not mark the file as Modified
* Fixed: When saving a file, either manually or automatically, any floating editors will not close.
* Fixed: The ➕ character in the hyperlink that starts a folded block is not always displayed in blue
* Fixed: The closing symbol for a folded block, ...[ ], will now always display in the same font and size.
* Fixed: It was possible to delete characters from an already folded text block in some circumstances.
* Fixed: Other corrections related to folding


v 2.1.0.4  Beta4 (04 may 2025)
--------------------------
* New: Configurable spacing between bullet and text is now available for all list types (#876)
* Replacement operations will ignore matches located entirely or partially in the hidden part of hyperlinks (#871)
--
* Fixed: IMPORTANT! "Control TKntRichEdit(..) has no parent window" -> Forces to kill KNT! (see discussions/868)
* Various fixes for interacting with a folded block (#869)
* Fixed: Folding doesn't allow to select certain entire lines (eg. bullets), ensuring the formatting of all of them (#873)
* Fixed: Prevent flickering when right-clicking on the (+) link of the folded block
* Fixed: Show floating editor with the same zoom ratio as the main editor
* Hided floating editor when the Editor Info panel is focused.
* Fixed: When exporting and "Folded Text" = Remove**, one of two contiguous folded blocks could remain unchanged
* Fixed: Exception when trying to open a folded block in the scratchpad editor when no file is open
--
* Minor improvement when entering tags and using TAB when the selector is displayed
* Minor fix when iterating through found words by clicking on the Find All search result
* Avoid possible flickering when searching (F3) in Scratchpad editor
* Fixed: Opening external KNT hyperlinks in other instances should not depend on "Load last-used file" and 
  "Create a blank new file if no file is loaded" options (#872)


v 2.1.0.3  Beta3 (27 apr 2025)
--------------------------
* Fixed: Too much editor flashing using Find Next (F3). Very noticeable when pattern not found
* Fixed: "Folded mode" option in Export wasn't working (regression in 2.0.1.2)
* Fixed: Exporting text fragments (using tags with "Consider text of notes") didn't work ok with folded blocks
* Fixed: When exporting text fragments or filtering nodes tag, and nothing to export, closing was asking for confirmation
* Fixed: Folding a partial selection of text with a highlighted background would lose the highlighting 
         on the floating editor and when unfolding
* Fixed: Tag name and description wasn't saved in UTF8 when needed
* Fixed: Tag input in editor was sometimes not recognized, especially in W11, mainly after adding from editor info panel
* Fixed a certain case when processing Tag criteria, where Without was indicated but not With
* Fixed: With and Without [TAGs] prevents TAB from advancing making it difficult to use screen readers like NVDA (#867)
* Fixed: Unhandled exception when clicking on a tag on certain, rare, situations
* Fixed: Find All using tags and "Consider text of notes" selected could not respect "Folded mode" option.
* Fixed: Some info/warning/error messages are shown behind the visible modal form or the floating editor.
* Fixed: Unhandled exception when clicking on a invalid KNTLink
* Added plugin "GoogleSearch.knl", similar to old 'googleplugin.knl', available for 32 and 64 bits


v 2.1.0.2  Beta2 (23 apr 2025)
--------------------------
* Used a more visible/clear character to mark the beginning of the folded block
  ** Note -> Unfold existent folded blocks with previous version before updating
* The floating editor can be opened by Ctrl+Clicking anywhere in the folded block
* Optimizations to reduce editor flashing (#859)
--
* Fixed: "Custom icon for this file" was not displaying the set icon (File|Properties|File Icons)
* Fixed: Jumping to external note didn't work when note wasn't in the active folder (#860)
* Fixed: TAB key inside the tree should set the focus to editor (#862)
* Fixed: Error message about the language file when starting up (#857)
* Reverted the change for solving issue #830 (Taskbar icon is always shown on main monitor)
  This fixes:
  * KeyNote and system tray (and activation Hotkey) (#858)
  * Splash of a black area in the Tree panel when maximizing from minimized (#854)


v 2.1.0.1  Beta1 (16 apr 2025)
--------------------------
Added two new functionalities:
** TAGs. Can be applied to notes, paragraphs, or text fragments.
** Folding and unfolding: You can fold text, hiding it and leaving a fragment visible.
   You can nest folded blocks, which can contain images, links, etc.
  --> See the help file for a full description
* Fixed: Exporting to .knt was not correctly considering selected folders. (#824)
* Fixed: KNTLinks were not being converted in MergeFile operations (2.0+), 
* Fixed exception in File | Copy To... (in x64)
* Fixed: Right click on a hyperlink doesn't work if caret is outside scroll view (#846)
* Fixed: Tree panel horizontal scrollbar always shown #845
* Fixed: Alarm form was not displaying the name of the note node  (#826)
* Fixed: Taskbar icon is always shown on main monitor (#830)
* Fixed: Enabled and checked state of the "Plain Text" entry in the editor context menu (if RO)
* Fixed: "Please wait for printer connection or cancel connection"
* Fixed: Find All with searches like "term1..term2" when term1 was at position 0 of the editor.
* Fixed: Ctrl+DblClick on a visible image didn't open the image outside KNT, but with internal viewer
* Fixed issue #822: The highlighting of the current node disappears
* Fixed: Opening KNT links in external instances ignored the marker (#838)
* Fixed exception when closing KNT while some toolbar is floating (#841)
* Fixed: Folder Properties (F4). RTL checkbox text overlaps the tab (in translation) #837
----
* Added 3 .INI options related to RTL activation: RTLkeyShct, IMEAutoKeyboard, IMEAutoFont
* Find All: Simplify results when only note names or metadata need to be considered, not content.
* Improved Scratchpad #693
* Hovering over a hyperlink now displays the URL in the status bar (#833)
* The state of the "Search All folders" option in the Find/Replace form is now remembered (.ini file)
* New INI option: "SimpleFileName" in "[ExportOptions]"
* KNT Links will ignore ">>" if included at the beginning of the file name, as unnecessary (#838)


v 2.0.5.3   (01 feb 2025)
--------------------------
* Added patch for issue #811: 2.0.5 .03
* Fixed: Nodes were not scrolled into view when clicking on internal link or search result

v 2.0.5.2   (31 jan 2025)
--------------------------
Fixed: Nodes were not scrolled into view when clicking on internal link or search result
 Regression in (2.0.5 .1) after adjustments for:
 * Fixed: Horizontal scroll's position is reset to show node into view when focused (#797)


v 2.0.5.1   (31 jan 2025)
--------------------------
* Fixed: Access violation when deleting or certain other actions with new/completely empty nodes (Ref #800)
* Fixed: Horizontal scroll's position is reset to show node into view when focused (#797)
* Fixed: Nodes were being shown shortened when they actually fit in the width of the panel (#797)
* Fixed: Moving to the left (Shift+Left) a subtree with thousands of children, while expanded, can cause a
  "ghost" node to appear as the last node in the tree. Ref: #803
* Fixed: RCtrl+RShft or LCtrl+LShft will only be handled as RTL or LTR on key release, and only if no other
  shortcut matches (Ref: #806)
* Searching for "..", "...", "aa...", "...aaa", etc. (without quotes) will assume "Exact phrase" as search
  mode instead of an [incomplete] search of words in the same paragraph or sentence
* Fixed: Double click to open in File Manager #807
* Fixed: Style names do not support Unicode


v 2.0.4.1   (20 jan 2025)
--------------------------
* Offered two versions: 32-bit and 64-bit.
* Fixed: Returned the tree panel horizontal scrollbar to its original behavior (pre 2.0.0) (Ref: #797)
* Fixed column reposition behavior (using drag and drop on column headers).
* Significant time reduction in Find searches
* Optimization of the caching process for data used to perform searches
* Optimized .knt loading, especially for files with a LOT of notes


v 2.0.3.1   (11 jan 2025)
--------------------------
IMPORTANT (2.0.0+): 
* Fixed: Saving is ignoring changes not yet committed, in other Folders editors (#791)

* Fixed: Incorrect margins in exported RTF
* Export: 'Page Setup...' and 'Preview' are now also available when selected RTF as the target format


v 2.0.2.1   (09 jan 2025)
--------------------------
(Detailed info in doc\Changes in 2.0.2 .01.txt)

* Added support for RTL (Right to left) languages

Print and Export improvements:
* KNT internal links are now converted to standard RTF format (works with MS Word and LibreOffice)
* Enabled (and redesigned) File | Print Preview
* Page numbering is added to File|Print... and File|Print Preview
* Added "Printer (PDF, ...)" as a new target format in File | Export.... (Preview available)
* Export. New options:
  * Table of Contents
  * Use of Sections
   - Section will start on a new page or be saved in a separate file
   - Section-dependent page header
  * Start each Note on a new Page 
  * Save each Folder to a new File
  * Insert page number as Footer
  * Body Font
  
* Added "cintanotes:" as a new URL scheme
* Find All panel: Change in layout  
* Fixed: After importing a TreePad file, there were no nodes visible
* Fixed: Some words marked as target for bookmarks could be [partially] ignored when removing hidden marks


v 2.0.1.1   (15 dec 2024)
--------------------------
(Detailed info in doc\Changes in 2.0.1 .01.txt)

* Fixed: Exception in Alarms form when changing the list of displayed alarms (create new, sort or change visible mode)
* Fixed: Page Setup Crash and other problems with Printing  (Ref: #647)
* Fixed: Tree right-click context menu not showing (mainly after double-clicking a node)
* Improved hot color (tree link) choice
* Added processing of "NT" token, where node creation and modification dates were registered in old version 1.6.9
* Functionality exposed from kntutils.dll is now included in keynote.exe (kntutils.dll is no longer needed)
* Updated *_WRK.LNG files ([work] translation files)


v 2.0.0.10  (07 dec 2024)
--------------------------
(Detailed info in doc\Changes in 2.0.0 .10.txt)

* IMPORTANT: New saved files can only be opened with version 2.0.0 +

* Language files (.lng) ready to be translated/updated. See #752 (Translating KeyNote NF)

* Fixed: After exiting the Find window (Ctrl+F) with ESC, "Find All" did not return all results.
* Fixed: Find Next could incorrectly select the first pattern found in a note with images (when traversing from another node)
* Fixed: Replace All could change an incorrect position when traversing from another node, if the current node has images
* Fixed: ClipCap with "Create a new node and paste into it" when copying from Scratchpad
* Fixed: Changing the image storage mode on a new, not yet saved file, throws an exception
* Fixed: Error when trying to "relocate" an external storage image of type ZIP
* Fixed: Ensured consistency between external storage type and presence or absence of .zip extension
* Fixed: Merge folder with images on file with EmbeddedRTF mode
* Fixed: Included 'KeyNote files' in drop-down list from File|Import...
* Fixed: Scrollbar position could be forgotten when returning to app with Hotkey (Ctrl+Shift+...)
* Fixed: Don't try to auto-close new (not yet saved) files
* Fixed: Option. "Show tooltips in tree" was ignored
* Fixed: Format|Background Color. Was changing *also* the default color
* Fixed: Paste Special with Ctrl, Shift or Alt, also available in the Scratchpad
* Fixed: Last export format (from tree context panel -> Export...) is updated in .ini
* Fixed: No way to expand dropdown controls using keyboard (Alt+Down shortcut)
* Fixed: Main toolbar position was ignored when opening application
* Fixed: Allow the use of Shift+TAB to move focus to tree in read-only folders.
* Fixed: Shift+Tab in Scratchpad editor: If there is nothing to unindent, focus is set to Note Editor
* Added: Pressing Ctrl+\ in the Scratchpad editor will switch focus to the Notes Editor
* Fixed: When another app modified the knt file, it could be marked as Modified before asking 'Reload the file from disk?'
* Fixed: hyperlinks without explicit protocol and with @ character were always interpreted as emails (mailto:...)
* Fixed: Allow use of UTF8 text in Lang\keynote.lan (and so in the language name list)
* Fixed: Translation of some drop-down lists was ignored
* Fixed: Alarms. Adjusted calendar control to required size based on locale
* Fixed: Exception in some systems with non-Gregorian calendar (ECommonCalendarError)

* NEW: It is possible to copy and paste selected images and text together from web browser
* Fixed: When pasting from browsers other than Firefox (such as Edge or Chrome), some formatting styles were ignored.
* Added caption to image pasted from web page, if available
* Fixed: Adjustments in "Paste external as Plain Text" / Plain text / Normal
* Exporting to plain text with "Show hidden marks and IDs": GID value is shown first and then the ID
* Added new RTF export option (Save images in default WordPad format)  [RTFImgsWordPad=False]
* Improvements and fixes to color selection buttons
* Change in behavior of ESC in the Scratch window
* Added new .INI option, to facilitate reading Hints through the status bar (Accessibility)

* Important rework and refactorization (See News in Help file)
* You can toggle between RTF and Plain text only in selected note (node)
* 'Plain text only' in the folder: used as default format for new empty notes.
* New: Creation/Last modification date in notes
* Added editor Information panel
* New: Tools | Deduce [missing] date information
* New: Tools | Remove date prefixes from node names
* Replaced TTreeNT with Virtual-TreeView https://github.com/JAM-Software/Virtual-TreeView.git
* Tree | Outline Numbering... Improvements. Completely reviewed
* Tree: Most actions can be applied on all selected nodes and optionally recursively on child nodes:
  Node color, node Font face, Custom icon, Bold attribute, Checked state, reset to default values,
  Move nodes (up, down, left or right), delete nodes
* Improved Copy / Paste and Drag and Drop operations
* "Mirror Nodes" becomes "Linked nodes"
* Added new Tree Filtering
* Two optional columns added to the tree panel: 'Flagged' and 'Date' (Note creation date)
* Added entry in tree panel menu, and toolbar button, to filter out unflagged nodes
* Filtering results. Use of 'Show children'
* After 'Filter folder[s]', it is possible to toggle whether or not to activate the filter
* Find All. Added new criteria: creation date / last modification date   (From / Until)
* New search option, Use path of nodes
* Find All: Clicking in a search result will iterate the different words of the match
* Syntax for additional/advanced search: 
  Considering last modification date of notes
  Words in the same paragraph or sentence
  Emphasized words, or also inside a same paragraph
* Find All: Revised the way 'All the words' search type works


v 1.9.5.2  (18 may 2024)
--------------------------
* Fixed: New created folders didn't show tree panel (Patch on 1.9.5.1)

v 1.9.5.1  (17 may 2024)
--------------------------
(Detailed info in doc\Changes in 1.9.5 .01.txt)

* New: Hyperlinks can use parameters, behaving similar to Favorites
* Added a new INI option: URLWebDecode to adapt URLs with %XY characters

* Fixed: Copy/Paste from web browsers did not work on systems with MBCS language (eg. Russian, codepage 1251)
* Handle possible exception in Windows 8.1 when trying to open the Font dialog
* Fixed: Tree panel width could be reduced on restart (if it was wide enough)
* Fixed: "F1" key cannot be used for any shortcut


v 1.9.4.1  (10 may 2024)
--------------------------
IMPORTANT:
 * Fixed: When importing *multiple* plain text files as new nodes, you may lose data when saving (Ref: #692)
 * Fixed: "Show word count in status bar" in notes with 30000+ chars can corrupt that note (Ref: #695)

* Fixed: Export could fail when exporting each note to a separate file (Ref: #696)
* Fixed: "Cut subtree" and then "Paste subtree" make a copy instead of move  (Ref: #690)
* Fixed: Exception in File|Properties on new file, not saved, if default image storage is External

* Now it is possible to import text files in UTF-16 LE and UTF-16 BE  (Ref: #692)
* The style definition file (keynote.kns) is now updated after each modification, not just on exit (Ref: #697)


v 1.9.3.1  (04 may 2024)
--------------------------
(Detailed info in doc\Changes in 1.9.3 .01.txt)

* IMPORTANT: 
  Files edited with this version should not be modified from a previous one (More in details file)
  -> Please, keep backup files previous to this version
  
* Scratchpad is now a normal full editor, equivalent to notes editor.
* The format and style toolbars, and menu options related to format now adjust to the selected editor
* Unregistered images can also be displayed in internal Image Viewer
* Scratchpad: Improvements in management of images (as a special editor, used from multiple files)
* Added new identification to each note (node), unique in the entire file: "GID"
* A new default format is defined for internal KNT Links based on the new GID identifier
* Added new command line option (-clnks) to convert links to new format based on GID
* Added "Cut Subtree" to entry "Transfer subtree" in tree contextual menu
* Adjustment in "Normal vs maximum tree width" functionality
* Optimizations in Replace All

* Fixed: Regression in exporting nodes with non ANSI characters to plain text
* Fixed: MergeFiles did not import images when the merged file used external type storage mode
* Fixed: Toggling word wrap in plain text notes lost font formatting
* Fixed: External storage path not being saved relative to .knt file in new files
* Fixed problem with ClipCap on some case use (see details)
* Fixed: Macro 'xxx' not found [Reload Resource panel data when displaying]
* Fixed: Using ImgFormatInsideRTF=ifWmetafile8, images were removed when executing "Restore Image[s] proportions"
* Fixed: Merge Folders- Did not respect plain text property. It always treated them as full RTF
* Fixed: Position of caret now only consider visible characters
* Fixed: Some (unusual) KNT Links didn't work ok (see details)
* Fixed: KNT Links not including mark ID could jump to an incorrect position in nodes with registered images

* Many other minor fixes and improvements (see details in Changes in 1.9.3 .01.txt)


v 1.9.2.1  (01 apr 2024)
--------------------------
(Detailed info in doc\Changes in 1.9.2 .01.txt)

* Fixed: Nodes not showing cursor position when opening
* Fixed: Cursor could be not visible on loading if zoom <> 100% and/or alternat. margin was set
* Modified the implementation of "Fix scrollbars" (e.g. to use with Linux-Wine)

* Fixed: Images not saved (in external storage mode) were lost if 'Reload Images' was executed
* Fixed: Images. Max.auto width on insert = -1 was not considering current zoom.
* Fixed: After running "Restore Image Proportions", the editor was displayed at 100% zoom
* New: It is possible to recalculate the ID of the next image to be saved

* Improvements (and 2 fixes) in "Normal vs maximum tree width" functionality
* Changes in Ctrl+Up/Down and Ctrl+Shift+Up/Down shortcuts
* Changed the default extensions filtered in Insert | Link to File menu option

* Fixed: The detection of URLs could be incorrect when other URL prefixes where present
* Fixed: Setting font size with Font dialog when scaling settings > 100% results in a larger font
* Fixed: Glossary did not correctly handle the backslash character
* Fixed: Glossary doesn't display correctly items that include '=' character inside the shortcut
* Fixed: Favorites in Resource Panel need to be refreshed in certain ocassions

* Refactoring. Simple notes disappear -> Switch to using only Tree-Notes
* Change of terminology: Simple notes / Tree Notes + nodes ==> "Folders" with "notes"



v 1.9.1.1  (17 mar 2024)
--------------------------
(Detailed info in doc\Changes in 1.9.1 .01.txt)

[IMPORTANT - You could lose data]:
 * Fixed: Importing RTF or HTML files as new nodes or notes could prevent recognition of the next node or note.
 * Fixed: Changes made in the Scratch panel are being discarded when selecting another tab in the resources panel.

* Fixed: UTF8 files without BOM were treated as ANSI files
* Improved: When navigating back in history it will return to the exact visible position in the editor
* New: Returning to a node now retrieves the exact position in the editor, including status bar scrolling
* New: Ctrl+Shift+Up/down will smoothly move the scroll bar vertically
* Improvements in "Normal vs maximum tree width" functionality
* Fixed: Export... It must be checked in the options that the "Symbols" field is not empty
* Fixed: Export notes... Error when selecting "Export each node to a separate target file"
* Fixed: Removed possible hidden characters when exporting from tree panel context menu
* Fixed: Editor needed to be refreshed in certain situations (if enabled Alternative Margins). Also Scratch editor
* Fixed: Import as new node or as new note always showed the Editor content at 100% zoom...
* Minimal change to try to resolve "Resource Panel>Favorites, not autocomplete"


v 1.9.0.1  (07 mar 2024)
--------------------------
(Detailed info in doc\Changes in 1.9.0 .01.txt)

* KeyNote NF release is signed with a Code Signing Certificate
* New: Added "Check for Updates" to Help menu. Can also be checked at startup (default: true)
* The application help has been completely updated, based on .knt format (as an alternative to .chm).
* Contextual help available based on .knt file (KeyNoteNF_Help.knt)

* Improved Tools | Customize Keyboard...
* Improved Insert | Character...
* New optional behavior of Tree panel
* Added 3 new menu commands, in Tree | Set Focus
* Changes in behavior of 'View Resource Panel' shortcut
* Changes in behavior of Find Next. Added new menu command: Search | Find All...

* KNT links to other files, in notes/nodes can be opened in the current instance or in a new one, at will
* KNT links in Favorites can be opened in the current instance or a new one, at will
* It is allowed to insert a KeyNote link (Shift+F6) in the Scratchpad editor
* The format of the internal KNT Link now admit relative paths (to keynote.exe) for knt files.
* The state of View | Alternative Margins is now saved in session/profile file (.ini file)
* The custom icon associated with a .knt file is now also visible in the taskbar and the main window

* Added a new INI option to make "closing this instance" warning optional
* Added a new INI option: ModifiedOnTreeResized
* Set Ctr+Shift+Y as default shortcut for Insert| URL ... (as indicated in help)
* Restored the original behavior of ESC in the Scratch window
* Esc in Find tab of Resource panel will also focus note's control editor if..
* KeyOptions.TipOfTheDay won't be automatically enabled when detected a new version
* Keynote.ini will be saved as UTF8 by default (if it doesn't exists)
* Removed menu entry Tools | Activate URL

* Added new command line option: -jmp"<KNTLink>"
* Added new command line option: -title"<TITLE>"
* Added two new command line options: -ignSI  -dnd
* Created a new add-on utility, KntLauncher.exe
* New: Save Tree to File... If Ctrl -> Show node IDs
* New option, "Show hidden marks and IDs", when exporting to plain text
* Improved the way another instance is activated. It will now be truly restored and become the foreground window.

* Fixed: KeyNote should not remember the minimized state of document when saving
* Fixed: Find All. Search results displayed incorrectly on two situations
* Fixed: Ctrl+Shift+0 was not working (default shortcut for Clear Paragraph Attributes)
* Fixed: Changing visibility of images in read only note removed images in the node, marking the note as modified
* Fixed: When playing macros of certain commands, all of them were executed as the first one
* Fixed: When restoring image(s) proportions and the Note is Read Only, always use a temporary method
* Fixed: Hidden characters where showing after 'Clear Font Attributes'


v 1.8.5.1  (03 feb 2024)
--------------------------
(Detailed info in doc\Changes in 1.8.5 .01.txt)

* Fixed issue #644: Export Notes Crash - Error Message and Application Freeze During Text Notes Export
* Fixed issue #642: KeyNote disappear after select 'Cancel' in the confirmation message box for exit with unsaved modification
* Improved Bookmarks 0-9: Now are persisted, and are linked to target through a hidden mark
* Glossary: shortcuts formed exclusively by non alphanumeric characters will be automatically recognized
* Revised behavior of color selection buttons
* Fixed: When navigating back in the history to another Editor (node or note), try to keep visible position
* Adjustment in history navigation
* Fixed: Exception navigating history to a deleted node
* Fixed: When pasting from clipboard, RTF should be prioritized over image
* Fixed: TAB multiple lines (#31) didn't work in plain text notes
* Fixed some bugs related to Export and UNICODE (see details)
* Adjustment on converting HTML to RTF
* Disabled for now the insertion of a hyperlink when pasting image from a web browser


v 1.8.4.1  (27 ene 2024)
--------------------------
(Detailed info in doc\Changes in 1.8.4 .01.txt)

* Fixed (IMPORTANT): Images and alarms can be removed from .knt file if it is saved after the New or Open actions.

* Fixed: Using View|Show Images (or button) showed the Editor content at 100% zoom, ignoring custom zoom applied
* Fixed: Remove KNT hidden characters from text obtained with "Copy node name" (with Shift)
* Fixed: Do not allow to insert images with Insert|Picture... in plain text virtual nodes
* Fixed: Update "Show Images" state after changing selected node

* Optimizations in Replace All
* Replaced ini option: IgnoreCtrHideTrePanel (default 0) -> UseCtrlHideTreePanel  (default 1)

* Menus: Added some icons, and other minor UI changes
* Alarms: Revised menu options and toolbar buttons. Other minor fixes

* Favorite items can be relative to Keynote.exe
* New: Allowed links relative to keynote.exe file
* It is allowed to select whether to include links to files/folders as relative or absolute
* Links: Added two INI options: URLFileEncodeName  and URLFilePrefNoHyp
* Fixed: Activation of relative links of the form file:///...
* Simplify insertion of external files links on plain text notes
* Fixed: Insertion of KNT Links in plain text note should use new style
* Fixed: Corrected the interpretation of several KNT Links variants



v 1.8.3.1  (29 dec 2023)
--------------------------
(Detailed info in doc\Changes in 1.8.3 .01.txt)
* Fixed: Paste operation could keep text selected in certain situations, afecting to ClipCap
* Export Improvement: Added new tokens and options for note/node heading
* Export Improvement: Added new options for indenting nested nodes
* BulletsInPlainText (.INI) now defaults to '- '
* Image Viewer now allows to scroll through the images of the current node (or note)
* Improvement: ApplyStyle can now be reverted with just 1 or 2 undo operations
* Corrected TAB order in Paragraph form
* Fixed: Pasting format could hide the text where it was applied, if copied from a line starting with a hyperlink


v 1.8.2.1  (23 dec 2023)
--------------------------
(Detailed info in doc\Changes in 1.8.2 .01.txt)
* New: Added options in treeview context menu to hide/show child nodes based on checked status
* Improvement in Find All. Added 'Check mode', with three options
* Improvement in Find All: replaced 'Search node names' option with 'Search Scope'
* Improvement in Find All. Matches in node names are highlighted in results list, with background color
* Improvement: Find All. All search types apply with 'Search node names'
* Fixed: Find All. Consider option 'Whole words only' when selected 'Search node names'
---
* Images. New: Ctr+Click on View Images (menu and toolbar button) -> Reapply hidden if Images Mode is imLink (images hidden)
* Fixed: Caret position after changing images visibility / Fixed: Bug in Find Next with images
* Fixed: Image viewer could not show scroll bars when zooming on certain occasions
* Fixed: Clipboard capture was ignoring images
---
* Improvement: When jumping to a location (eg. click on a hyperlink), show the destination on the first line of the editor
---
* Fixed: Pressing left or backspace on the first character of a cell in a table raised an exception
* Fixed: Eliminated flickering when displaying the search screen (Find Next)
* Fixed: When deleting a node, the new (automatically) selected node was not showing with correct zoom, nor was updated the status bar
* Fixed: Non controlled exception "FORMATEC structure not valid" on Paste Special... pasting from certain pages
* Fixed: "FORMATEC structure not valid" exception pasting from certain pages


v 1.8.1.8  (14 dec 2023)
--------------------------
* Fixed: Null values (#0) could appear sporadically, corrupting/truncating part of the node content
  More info in https://github.com/dpradov/keynote-nf/issues/623#issuecomment-1856346322

v 1.8.1.7  (11 dec 2023)
--------------------------
(Detailed info in doc\Changes in 1.8.1 Beta1-6.txt)

* NEW: Significant improvement in image management
  A detailed explanation is available in "doc\Images_Readme.txt"
* Drag and drop directly to Editor's content
* New option in the import window: "Insert content at caret position"
* Added option to replace bullets by alternative string when pasting as plain text
* Improvements for profiles management | Profiles\Default | Profiles macros
* Fixed: KNT could get hang doing a Search (Find Next or Find All) [IMPORTANT]
* Fixed issue #617: Access violation on exit
* Fixed issue #621: "Allow only one instance" not working
* Fixed: Text selection with Shift + left cursor is canceled when crossing a hidden mark
* Fixed: Convert '&quot;' to '"' in title from web pages
* Fixed: newly added nodes do not respect the established zoom
* Fixed: New KNT Links could jump to an incorrect position  
* Fixed: Possible exception on exporting (File | Copy To...  or File | Export... with KNT format )
  when including plaintext notes	
* Improvement/correction to the RemoveKNTHIddenCharactersInRTF procedure
* Other minor adjustments


v 1.8.0 Beta 1 - Beta 6 (01 aug 2023 -- 06 sep 2023)
------------------------
(Detailed info in doc\Changes in 1.8.0 Beta1-6.txt)

* Adaptation from Borland Delphi 2006 to to Embarcadero Delphi CE 11.3 (Community Edition 11.3  Alexandria).

* Find All: Improvements
 - Excerpts from the note of the matches found, where searched words are highlighted
 - Search is now much faster
 - Added new option: "Current node and subtree"
 - The treatment of the options 'All the words' and 'Any of the words' is extended

  * Changed: The option "Reverse order" it is used now only with the the option "Show full node path in status bar".
  * Fixed: The option "Show full node path in search results" was not used. 
  
* New KNT Links, vinculated to markers, not only to caret position
* Redesigned navigation history mechanism
* New: Added 'KeyNote' as target format in File/Export...
* Improved Alarm management window. Revised design and usability
* Added a new property, "Default Zoom": Allows to use a default value other than 100%
* Changed behaviour of Zoom Text action.
* New: View | Alternative Margins
* New: pressing [Ctrl] + <Hide Tree Panel> will temporarily preserve editor width, reducing the application window width
* Fixed: High DPI displays. The application should scale correctly based on OS settings
* Improvement in the design of the form Configuration Options
* Optimization in file open/save, mainly in native format
* Fixed possibly difficulty on saving, if file is located in a externally synchronized folder (for example with Dropbox)
* Fixes and changes in URL actions
* Improved click options on hyperlinks
* Fixed: Option "Use system default web browser" was not working 
* Clipboard Capture / Web Clip / Paste external
  - Try to offer RTF Format in clipboard whenever possible (from HTML format)
  - When pasting from HTML (web pages), the current font and size in the active editor will be used as default values, 
    instead of the usual Times New Roman 12.
  - When converting from HTML to RTF, on pasting from web pages, last aditional line break will be removed
  - Fixed: Pasting as plain text could move the caret several characters before its correct position  
  - Fixed: copying and pasting from certain web pages can produce nothing or truncate some text
  
* Improvements on Clipboard Capture / Web Clip capture 
  - Added new token: '%%'
  - Ensure to include Title for URL  (%S, %s, %U)
  - Titles from web pages: convert HTML Ascii codes  
  - Added new token: source server/domain (%d)
  - Revised and improved predefined dividers
  - Adjustment in the option "URLOnly"
      
* Clipboard paste / copy / cut
  - Fixed bug that could affect the paste action, when determining if normal or plain paste should be applied
  - Fixed bug that made that the option "Ignore duplicate clips" were ignored
  - Fixed: An exception "Cannot open clipboard: Access Denied" could occasionally be raised
  - Fixed: The option "Limited size to", in Advanced/Clipboard ("Maximum length of text to capture, in bytes (when paste as plain text)")
    should only be considered for Clipboard Capture, not for normal plain paste (nor Web clip)   

* Several fixes and enhancements related to 'Note properties...'  and 'Default Settings...'
  - Changes in design and functionality in "Default settings.." (F6) and "Note properties.." (F4)
  - Modified several captions and hints to avoid possible confusion between color of nodes and color of editor
  - Changed: Moved the option 'Inherit BG color from active node' from 'Tree panel' section to 'Rich Text editor'.
  - Added: Font and BG color can be changed for ALL tree panels at once
  - Fixed: modifying the properties of a note (Note properties..[F4]) could cause font formatting to be lost in certain situations
  - Fixed: sometimes the defined default font properties of the note where ignored on new nodes.
  - Fixed: Changes in tree font didn't update correctly
  - Fixed: Sometimes changes from Note Properties (F4) did not modify the status of the file (to modified)
  
* Fixed: Making bold a tree node din't maintain other possible styles of the default TV font
* Fixed: Option "Autoregister file type" now works ok without any special permissions
* Fixed: Change in read-only state of a note => save button state
* Fixed: Ensure that all nodes in a RTF tree note are saved in RTF format, and all nodes in a plain text only tree note are saved in plain format.
* Fixed: Text files imported as a new note note could be saved plain, not RTF
* Modification in RxRichEd to change the way a retry is made when the load of stream detects an error
* Fixed possible exceptions when no file was loaded
* Changes in log management

* At the moment, the Send Mail functionality will not be included in KNT


v 1.7.9.9 Beta (07 jul 2017)  (Distributed as 1.7.9 Beta 9 Test.2)
--------------
* Implements #11 (New button: 'Copy Format') and Improves Copy/Paste Font Attributes and Copy/Paste Paragraph Attributes
* Fixes #568: Can't paste PHOTOS into KeyNote NF (after June 14, 2017 Win10 update)
* Fixes #565: Paste as text not working in Beta 8
  "Paste as text" was doing nothing when adding (not when replacing a selection) more than one line.
* Fixes: when modifying a node's name, the toolbar save button is not being enabled
  Also, being the first change in the file, other modifications, like writing in a note, wouldn't enable that button.
* Fixes #566: How to turn off the prompt "file is not modified, nothing to save"
* Changed some defaults (#542 #570)


v 1.7.9.8 Beta (30 abr 2017)
--------------
*  #564 : Modified nodes could be truncated (content partially losted) on saving (with RichText 4.1, in XP and W7)
*  Fixes: File properties -> Settings -> Open '<File>' as Read-Only - Was not working   (5b5a0ad40bc7c54681c5a603c3635d745b61ce02)
*  Fixes: Filename is converted to lowercase when opened from command line (or explorer) (8428f05d5b3159d9a3edced82a82e09a4cff536b)
*  Adding extension when 'saving as', with no extension and file format is KeyNote compressed file (nffKeyNoteZip) (3284e5ddd08b06908dca9145830c68c735da9de3)
*  Minor optimization: 9f28a03da58ae5e0d26cff87dee470c8f47e04d1


v 1.7.9.7 Beta (08 mar 2017)
--------------
*  #554 : Missing notes (IMPORTANT!)
*  #544 : New option to keep backups at regular intervals
*  #552 : Avoid continuous saving / "Failed to create output file" error
*  #538 : Reimplement TAB multiple lines, while preserving old Shift+TAB behaviour
*  #543 : Cut and paste is pasting always as plain text if 'Paste external as Plain text' is checked (Beta 6)
*  #558 : Always assume 'Search Type' equal to 'Exact phrase' when searching only one word [Find All]
*  #541 : Display problems with Find results
*  #402 : Auto indent failed when line wrapped
*  #552 : When there are no modifications, the Save button will be disabled
*  #540 : Revise and optimize the correction of some corrupted RTFs
*  #539 : Pasting as plain text moves the caret beyond pasted text when it includes several lines
*  Corrected: INTRO inside or stuck on the left of a hyperlink doesn't behave correctly if AutoIndent enabled
*  Adjusts issue #38 when line wrapped (#38: HOME key, could put caret on first non-space position)
*  Several optimizations, like the following commits:
   e172e867dc5cb50f97d5c5e907c953c03b92adfb, 6967f735100a47d8908aa64ea36b49de1cb33de7, 
   4d848a9085d5787071e47602d239aa11bc577aea, 715a8a2ac2c1a28191f82bc8efa25bb94b704628


v 1.7.9.6 Beta (03 jan 2016)
--------------
536 Various corrections and improvements (fixes also several bugs introduced in Beta 5)     
217 Setting or Changing a node name using an Asian IME garble the name
534 Corrections related to encoding (ANSI / UTF8)
410 Unicode BOM characters randomly inserted into ANSI Virtual Node text files
537 Possible elimination of images on a ReadOnly note (in W10)
520 Scroll on note when switching notes (includes an important optimization, see issue)
408 Show word count in status bar: makes keynote lag enormously with long texts
495 Cannot display system file properties window
328 Expression > Paste last result: Wrong behaviour after error in evaluation
179 Should be 12PM not 12AM


v 1.7.9.5 Beta (26 dec 2015)
--------------
#533 : New option: "Paste external as plain text"
#532 : Improvements on Clip Web and Clipboard Capture
#523 : Use Paste as Text by default when pasting into plain text note
#528 : Minor improvements in links
#526 : "Search all notes" in Find dialog and panel should be decoupled
#529 : Paste Font Attributes destroy selected hyperlinks when applied (in Richedit <= 5.0)
#524 : Problem with MS Sans Serif in Windows 10 in certain situations
#530 : Allow the use of newer versions of RichEdit
#286 : Extend node search capability to search all notes-tabs
#415 : Clicking on a tab should not change its position when "Multiline tabs" is selected
#411 : Word Wrap Issue / #77: Note display corrupted on resizing
#457 : virtual node files can't be backed up
#456 : Search regression with Beta 4
Correction over issue #403: Hyperlinks should accept any URI protocols (as callto or ms-help, among others)


v 1.7.9.4 Beta (7 jan 2013)
--------------
    Issue #327: Re-select Find / Replace dialog window after closing the "Not found" pop-up
    Issue #404: Corrected and improved Find/Search behaviour
    Issue #436: Minor improvements in Style combo box
    Issue #369: Problem entering text via Tablet PC Input panel
    Issue #343: Opening file as Read-Only: you can lose your file
    Issue #330: Link to file can't be opened when file name contains a plus sign
    Issue #403: Hyperlinks should accept any URI protocols (as callto or ms-help, among others)
    Issue #437: Links with Hebrew characters don't work
    Issue #91: Angle brackets around links multiply
    Optimizes CleanHyperlinks operation (see issue #59: Certain hyperlinks may cause knt file to grow in size suddenly (geometrical increase..))
    Correction: Insertion of Date is now realized in Unicode (now working in region settings like Hebrew)
    Issue #451: Slight improvement in import method by drag and drop
    Issue #453: Time needed to close can be high in certain environments
    Minor modifications related to Issue 193: Adjustments in alarm window
    Issue #450: Access violation exception when moving nodes to onother note
    Issue #420: Error when opening encoded URL or URL that contains spaces
    Issue #408: Show word count in status bar: makes keynote lag enormously with long texts
    Issue #298: HTML Export is not working (Revised HTML Import and Export)
    Issue #323: Include formatting and links when pasting selected text from Firefox (offer RTF when there is HTML format at least)
    Issue #385: Rename node using F2
    Issue #97: Improve form 'Customize keyboard shortcuts'
    Issue #324: Export error in displaying Chinese node name
    Issue #410: Unicode BOM characters randomly inserted into ANSI Virtual Node text files
    Issue #406: Bug when copy/pasting Paragraph Attributes


v 1.7.9.3 Beta (18 ago 2011)
--------------
    Issue #193: Adjustments in alarm window 

Notes about compatibility:

  - This new version (beta) recognizes and includes alarms of old versions. That alarms will have reminder
    date and subject and no event/expiration date.
  - You will be able to open a file modified with this version in an older version of KeyNote NF, but you
    should take into account the following:
     - Older versions doesn't recognize note alarms nor several alarms in the same node. So if your file
       has that kind of alarms you will lose the first one and only will see one of the second.
     - All the formatting in the alarms (bold and colors) will be lost.
     - And most important thing: you MUST remove or restore alarms marked as Discarded before open with
       an older version. Otherwise you will receive errors like:
        "Error loading note XX 'D07-09-2010 21:30:0............' is not a valid date and time" and the
         remainder of the note is ignored. And finally you would receive the message: <<One or more errors
         ocurred while loading the file. The file may not have loaded completely. To minimize he risk of 
         data loss, the file was opened in Read-Only mode. Use the "Save As..." command to save the file>>


      More information in: http://keynote-newfeat.sourceforge.net/forum/viewtopic.php?f=18&t=47


v 1.7.9.2 Beta (7 ago 2011)
--------------
   Issue #395: Keynote NF doesn't open my file, "buffer error"
   Issue #325: Relative paths in Links (relative to .knt file)


v 1.7.9.1 Beta (7 jun 2010)
--------------
    Issue #61: Improve lists (bullets and numbered lists): different styles, sublists, ...
    Issue #325: Relative paths in Links (relative to .knt file) 

    Issue #251: Alarm Text Entry can make KeyNote to crash
    Issue #258: Alarm date displayed incorrectly when the day was the same as today
    Issue #224: Alarm window - date/time selection conflict - see screenshot
    Issue #306: Exception setting alarm in no saved files (untitled)
    Issue #77: Note display corrupted on resizing
    Issue #107: Name of new nodes created by 'New node from selection' and clipboard capture with option 'use clipboard text' may be too long
    Issue #264: Clipboard Capture with 'New node name' set to 'Use clipboard tex'" can cause the program to crash
    Issue #136: Find with 'search all notes' can cause Keynote to close
    Issue #198: Chinese characters detected erroneously as UTF8 in import
    Issue #202: Cyrillic plain text in old .knt files is shown as Western characters
    Issue #200: Inconsistent bullet indentation
    Issue #208: Notes with links scroll on save
    Issue #213: Clicking URLs in About menu results in Unexpected error: Invalid class typecast
    Issue #242: Links incorrectly formed in Windows 7
    Issue #227: Tab key causes tab to be inserted even if Note is set to "Read Only"
    Issue #247: Exit with automatic saving causes Keynote to open minimized next time
    Issue #279: Search all notes function can cause address violation
    Issue #288: Underscores are dropped while exported to single target files
    Issue #294: Minor bug on "Set Bookmark" and "Jump Bookmark" keyboard shortcuts 


=============================
Version: 1.7.8 -  date: 02/nov/2009

Enhancements:
 * Issue #175: New KeyNote file format: compressed
 * Issue #72: Ability to add notes to an alarm event, and other minor changes 

Bugfixes:
 * Issue #162: Changes to last node are not saved in encrypted *tree* notes if focus is not moved to another node
 * Issue #163: Paste as web clip is not showing source URL
 * Issue #166: International input is not working when renaming nodes in tree
 * Issue #169: Searching Next with Enter Key pressed could modify note content
 * Issue #178: Program freezes when saving/closing
 * Issue #189: Changes on a node are lost if a new note is created before moving to another node or note

=============================
Version: 1.7.7 -  date: 18/oct/2009

Enhancements:
 * Issue #139: Make KeyNote NF Unicode compliant
    Before, within the same version:
     * Issue #40: Find and Replace operations don't work with Unicode characters (Chinese, for example)
     * Issue #54: 'Paste as Text' and 'Paste as Web Clip' don't work with Unicode characters     
 * Issue #73: Allow to enable or disable alarm popups
 * Issue #29: Sound for Alarm
 * Issue #135: Insert URL auto-clipboard-paste
 * Issue #158: Add support for Notes URL Protocol
 * Issue #118: KeyNote should admit relative paths in config file and command-line
 
 * Included a partial French translation by Picou (picou.keynote@gmail.com)
 * Included a partial Chinese Simplified translation by xbeta (http://xbeta.info)
   In both cases .tip file isn't translated
 
Bugfixes:
 * Issue #155: Clipboard capture error on non active (visible) note
 * Issue #141: Clipboard capture repeats twice the text copied, when the copy is made from certain programs
 * Issue #62: Keynote NF won't open in maximized window state
 * Issue #58: Minimizing button does not work.
 * Issue #153: Display Problem on clicking Hyperlink
 * Issue #63: Hyperlinks not working with Unicode characters
 * Issue #115: Right click on URL problem
 * Issue #149: Add sibling command doesn't always add a sibling node
 * Issue #127: StyleApply macro doesn't apply specified style. Modifiers keys don't work in macro, too
 * Issue #125: Cursor jumps to last textual hyperlink in note each time note is saved.
 * Issue #122: Keynote links to another file don't work
 * Issue #116: Changes in mirror node get lost after saving if original node is selected (in other note)
 * Issue #101: Import files by dropping them on the tree
 * Issue #96: Search -> Find... only works on one note, won't search all notes.
 * Issue #74: The treeview in the options dialog is editable
 * Issue #71: Node can become unchecked when moving, in a special situation
 * Issue #70: Status bar doesn't reflect correctly the modified state of the file
 
   While the Beta 2 was available were identified the following issues, now resolved:
 * Issue #152: "Allow only one instance" is not working in 1.7.7 Beta2
 * Issue #150: Exporting tree to file does not include headers
 * Issue #140: Note tabs no longer appear in 1.7.7 Beta 2 for encrypted notes files
  

=============================
Version: 1.7.6 -  date: 15/Mar/2009

Enhancements:

 * Issue #57: New kind of virtual nodes: links to other nodes (Mirror nodes)
    - You can create mirror nodes so that they share the same content, alarm and checked state. That way you can organize your
    information simultaneously in different ways
    - With mirror nodes you can have task spread over many tabs, and at the same time include in another tabs. You will be able
    to have a global vision of the main things to do, sorting, ranking and structuring in a free tree hierarchy, independent
    of the hierarchy in wich 'real' nodes reside.
 
 * Issue #48: Ctr+Shift+TAB, before selecting previous page, focus on tree 
 * Included a complete Dutch translation by Ennovy and Plankje (http://forum.goeiedageven.nl/)
 
Bugfixes:
 * Issue #59: Certain hyperlinks may cause knt file to grow in size suddenly (geometrical increase..)
              There is a new command line option (-clean) to clean/repair a file with that problem (perhaps latent..)
 * Issue #50: Tabs context menu and Export...
    
    
=============================
Version: 1.7.5 -  date: 31/Jan/2009

Enhancements:
 * Issue #23: Multilanguage version of KeyNote NF  (new configuration option)
              In this release is included a file with a partial translation to spanish (castilian). This
              serves as an example of how to translate. In the content of the issue there is more information.
 * Issue #31: TAB and SHIFT-TAB over multiple lines behaves like notepad++
 * Issue #32: Holding Ctrl+UP/DOWN allow to shift document
 * Issue #38: Pressing HOME key moves caret to first non-space position of line.

Bugfixes:
 * Issue #24: Couldn't see the content of the nodes (DLL different from MSFTEDIT.DLL didn't work)
 * Issue #26: New format of links (issue 12) didn't work with notes checked as "Plain text only" 
 * Issue #27: Converting old links with the prefix "file:///?" to the new format didn't work
 * Issue #42: First line indentation didn't work as should. Now indentation behaves like in MS Word:
              First indent is relative to left indent, not vice versa. And can be positive or negative.
 * Issue #36: Shift+Ctr+` (Decrease first indent) didn't work.
 * Issue #33: AltGr+C/V/X was ignored
 * Issue #28: Starting 2nd instance crashed if option "One instance only" was checked.
 * Issue #41: File names were always saved in lower case
 * Issue #39: In version 1.7.4 compiled from SVN search may not work.
 
 
=============================
Version: 1.7.4 Rev.2 -  date: 02/Jan/2009

Bugfixes:

 * Issue #20: Paste with Shift-Insert: as Text

 * Issue #21: Changing font style of a selection

=============================
Version: 1.7.4 -  date: 29/Dec/2008

Enhancements:

 * Issue #12: Improving the way links are managed. In new versions of Rich Edit is used the command RTF:
	     {\field{\*\fldinst{HYPERLINK "hyperlink"}}{\fldrslt{\cf1\ul textOfHyperlink}}}
	     Now hyperlinks can show a text different to the URL.

 * Issue #7: More general and improved use of usual clipboard's shortcuts:
             Ctrl-C, CTRL-V, Ctrl-X  / Ctrl-Ins, Shift-Ins, Shift-Supr.
             That way is possible to copy and paste nodes and subtrees, and move (cut and paste) inside the file.

Bugfixes:

 * Issue #10: Changing First Indent of selection with several lines.
 	      Resolved in a better way, using PFM_OFFSETINDENT in RichEdit, instead of PFM_STARTINDENT
              Now works ok, and don't consume the 'undo' mechanism.

 * Issue #9: Pressing Intro in an empty line with bullet or numbering list style,
	     should cause list style to be removed..

 * Issue #13: Behaviour of lists styles: When applying list styles, the first indent of list 
	      (bullet or numbering) is not homogeneous

 * Issue #14: Context menu for Note tabs didn't appear under cursor
 * Issue #15: It is allowing RETURN even in read-only mode
 * Issue #16: Failed to save after erasing a node with hidden childs
 * Issue #18: Inserting a node doesn't always shows ok if the previous one is hidden.  


=============================
03 october 2008 - version 1.7.3.3

* Fixed problem with function "Insert URL..." and "Insert Link to file...": it didn't
  work. It just transported the first letter of the url.
  On correcting the cause of this error it has been also resolved the problem with option
  "Show word count in status bar". The behaviour of the status bar is now the usual 
  in KeyNote.

-------------------------------------------------------------
02 october 2008 - version 1.7.3.2

* Issue related to Paste action was not correctly resolved. It could generate exceptions in
  certain situations caused by the behaviour of "msftedit.dll". 
  I have implemented a different solution that never needs to open modal window PasteSpecial.

-----------------------------------------------------------
30 september 2008 - version 1.7.3

* Fixed problem with searches: using "msftedit.dll" messages EM_FINDTEXTEX 
  doesn't work correctly. Instead I have used EM_FINDTEXTEXW, that uses search strings
  in Unicode.

* Fixed issue related to Paste action: sometimes Paste was ignored, while Paste special 
  still worked.
  Now that situation is detected and the actions followed by the program are:
  - first to try to paste in Rich Text Format (like PasteSpecial but without UI, and selecting
    directly the format)
  - If action one didn't work (in very rare ocassions) then KeyNote will open modal window 
    of PasteSpecial. And this allways work.

-----------------------------------------------------------
28 september 2007 - version 1.7.2

* Added: Now, you can use and show **tables** correctly inside KeyNote
  - This improvement is available from Windows XP SP1, by means of "msftedit.dll"
  - At the moment, to control the design of these tables you must use other programs like Excel
    or Word and paste then into your keynote file
  - This functionality is actually incompatible with option "Show word count in status bar"
    The option is simply ignored.

* Minor improvements in alarm management:
  - You can close modal window with ESC
  - When you postpone an alarm, next visible alarm is selected and option applied is mantained as
    default for next one.
* Fixed exception on Delete Style Definition. This error appeared when migration to Delphi 2006.


-----------------------------------------------------------
23 july 2008 - version 1.7.1 (Rev. 4)
* Fixed exception raised when opening KeyNote with impresion queue stopped (server RPC stopped)

-----------------------------------------------------------
16 july 2008 - version 1.7.1 (Rev. 3)
* Fixed error relative to alarm setting: it raised an error on opening a document with alarms from
  another document with alarms, too (also, on reopening a document when was modified outside KeyNote)

-----------------------------------------------------------
25 November 2007 - version 1.7.1
* Added: setting of alarms, associated to nodes.

-----------------------------------------------------------
13 November 2007 - version 1.7.0

* Added: Capacity to work with hidden nodes. Nodes can be hidden in two ways: 
  - Activating a mode wich automatically hides checked nodes (Show or Hide checked nodes) 
  - Filtering one note's nodes or all notes under a searching criterion (Filter Tree Note) 
   In searches (and filters) it is possible to select if to consider or not hidden nodes.
   If you click on a result relative of a hidden node, that node will be shown.
* Added: Selecting checkboxes for all nodes is still posible.
	(View/Tree Checkboxes -- now View/All nodes Checkboxes) 
   Besides, checkboxes can be shown only on children of selected nodes:
   (Children Checkbox) 

* Fixed error that could affect searches, exports and sending of mail: in rare ocassions
  one node's content could prevent next nodes to be considered.
* Fixed: checked state of a node is now mantained when moved (by drag and drop or by Shift
  and cursors) and also when nodo or subtree is transferred.
  At the moment, if a node with visible checkbox is moved to a parent node that doesn't show
  his children checkboxes, this moved node will not show its checkbox (but the checked state
  is mantained, it isn't lost)

* Changed behaviour of ESC in Scratch window: instead of focusing note's control
  editor, keynote is minimized.


12 November 2003 - version 1.6.5
* In Options - Other you can now specify a custom web browser
  to use for launching URLs, or tell KeyNote to use the system
  default web browser.
* Added Paste as Web Clip command (Edit|Paste other or Shift+Ctrl+W).
  This command does a normal paste, but if HTML data is available on
  the clipboard, KeyNote attempts to retrieve the source URL address.
  If you copy text to clipboard from a web browser, KeyNote should paste
  the text together with the original location (URL) of the text. So far,
  his works only with Internet Explorer, because Mozilla does not place
  the URL on clipboard, while Netscape and Opera don't render CF_HTML
  format at all. (Settings for the Web Clip command are shared with
  Clipboard capture, but WCDivider and WCPasteAsText options can be
  modified via ini file.)
* Fixed problems with creating file type associations.
* Main windows state (minimized, maximized) should now be correctly
  preserved. Note that it might interfere with the "Start minimized"
  configuration setting or the "-min" command line switch.
* In tree-type notes, each node now has an independent word wrap setting.
  that is, word wrap can be ON for some nodes and OFF for others.
  (Initially each node uses the note's setting.)
* You may remember that, when the editor panel has focus, pressing
  Alt+Up or Alt+Down arrow navigates to the previous or next node
  in the tree. Now the reverse is also true: when the tree is focused,
  you can press Alt+Up or Alt+Down arrow to scroll the editor up or
  down.
* Now possible to merge current file with itself. This is an easy way
  to create a copy of a note in the same file.


6 January 2003 - version 1.6.1
* For those interested in the development of KeyNote 2.0, there is now
  a new KeyNote 2.0 Development FAQ: http://www.tranglos.com/free/knt2devfaq.html
* Custom date and time formats, available under the drop-down menus
  attached to the "Insert Date" and "Insert Time" buttons on the
  toolbar are now configurable. See files "dateformats.txt" and "timeformats.txt" for information on how to customize them. It is
  also possible to specify that the date should be inserted using
  English names of months or weekdays (by default, KeyNote uses
  localized names, according to the Windows language version).
  Shift-clicking the Insert Date and Insert Time buttons will
  reload the appropriate configuration file.
* For virtual nodes, relative paths are stored in the KNT file
  in addition to absolute paths. When loading a file, the
  absolute path is tried first. If the file referenced by the
  virtual node is not found, KeyNote tries the relative path.
  This should make it more convenient to tranfsfer KNT files
  containing virtual nodes to other media, e.g. CD-ROMs.
* Fixed a bug which prevented KeyNote from saving newly-added
  'Favorite' items.
* Fixed a bug in automatic outline numbering, where zeros in node
  numbers were not stripped correctly while renumbering the tree

1 January 2003 - version 1.6
* Changed the method used for opening local (file:///) URLs. It should now be compatible with Windows XP and systems where the file: protocol may not be correctly set up. If you still encounter problems, especially with file paths that include spaces, please edit the following entries in the "keynote.ini" file:
URLFileDecodeSpaces=1 (change to:  URLFileDecodeSpaces=0)
URLFileQuoteSpaces=0 (change to: URLFileQuoteSpaces=1)
(Note that you must close KeyNote before modifying the INI file.)

27 December 2002 - version 1.5.9

* Hiding the tree panel is now remembered. When the file is saved and then reopened, the tree panel will remain hidden, until you un-hide it with the View - Tree Panel command.
* KeyNote now remembers whether the tree or the editor was focused when the file was last saved, and the same control receives focus when the file is reopened. (By default, the RTF editor is focused, rather than the tree, which changes the standard behavior of earlier versions.)
* It is now possible to hide the status bar (View - Status Bar)
* New "Properties" command added to the Favorites context menu allows renaming and modifying existing Favorite locations.

[Version 1.5.8 is not documented here, it only included new URLs and contact information, but no changes in functionality. Version 1.5.7 was never released.]

27 September 2002 - version 1.5.6
* Fixed a major, though probably rare bug: if the Undo command was invoked immediately after invoking the WordWrap command (e.g. by pressing Ctrl+W followed by Ctrl+Z), the text in the editor would be cleared with no way of restoring it.
* When customizing note icons, it is now possible to add more than one icon at the same time using the "Open" dialog box.


28 July 2002 - version 1.5.5
* All clipboard capture problems (that I know of) have been FIXED; including any instances of duplicate captures. This is a work-around for problems that some MS applications cause. (This feature is ON by default, and can be disabled in Options/Clipboard Capture.) The "SleepTime" option is still honored, altough it should not be necessary any more, and you can set it to 0, or to a smaller value than you have used previously.
* When clipboard capture is ON, KeyNote now displays an alternate (orange) icon in the tray area, to indicate that the program is capturing clips. Previously, the orange icon was "flashed" for a moment each time a clip was captured. Currently, KeyNote simply flashes the other (normal) icon. If you wish to restore the original behavior, you can disable the "Use alternate tray icon" in Options/Clipboard Capture.
* Added option to disable the confirmation dialog box when clipboard capture is initiated in tree-type note.
* Fix for "Insert URL" function; the '#' character in URLs is no longer encoded into a hex string.
* Added a workaround for situations where KeyNote cannot find the uas.exe (UltimaShell Autocompletion Server) - when this happens, KeyNote will prompt you to enter the full path to uas.exe and will store the path in keynote.ini.
* Virtual node-related commands in tree panel context menu are updated properly now (they would occasionally go out of sync with the actual state of the selected node)
* When refreshing a virtual node, KeyNote now warns you if the node has been modified within KeyNote. If you click OK, any changes made in KeyNote since last save will be lost, and the node will reload the original file from disk. If you click Cancel, the node will retain the changes you made to in within KeyNote. (If you have modified the node's original file using another application, you can refresh the node to reflect changes made outside of KeyNote.) Please note that virtual node files are not automatically monitored for changes and, due to system resources this would require, cannot be. If you modify a virtual node file outside of KeyNote, you need to "refresh" the node manually; hence the above warning message.
* Added last modification date and time to file information in the File Manager dialog box.
* Added drop-down menu to the "Paste" button on the toolbar, making it easier to choose a format to paste. (The button itself always performs the "normal" paste command).
* It is now possible to hide the following elements of the toolbars: the Font Name drop-down list, the Font Size drop-down list, the Zoom drop-down list, the Font Color and Font Highlight buttons. To do so, first save the current toolbar layout by using the following new command: View -> Toolbars -> Save Configuration. Next, edit the "toolbar.ini" file as you did before; you will find a new section called [Special]. This section contains new settings for the controls listed above. Change settings and save the toolbar.ini file, then reaload toolbar configuration in KeyNote by using the following command:  View -> Toolbars -> Refresh Configuration
* It is now also possbible to hide the separators on toolbars. This is useful if you have removed several buttons and end up with several separators in a row, wasting toolbar space. Again, this has to be done manually, by editing the "toolbar.ini" file. Separators on the Main toolbars have names such as smXX, where XX is a number between 1 and 10, while separators on the Format toolbar have names such as sfXX, where XX is a number between 1 and 8. Originally, the separators will notbe listed alphabetically, but the numbers indicate the order in which separators appear on toolbar, so if you want to hide the second separator on the Main toolbar, set "sm2=0"; setting "sf8=0" will hide the last (8th) separator on the Format toolbar.
* Added a new "Insert" toolbar, with buttons for inserting date, time and special symbols. The new functionality is in the drop-down menus attached to each button, which allow you to quickly select the desired date/time format or one of the most recently used special characters. The toolbar is not displayed initially; you will need to enable it by using the View -> Toolbars -> Show Insert Toolbar command.
* It is now possible to activate a hyperlink via keyboard (Tools menu -> Activate URL). By default, no keyboard shortcut is assigned to this command; please pick your own using the "Customize Keyboard" command. (Thanks to Dmitry Bobrik for the tip!)
* The "auto-close" function has been enhanced in two ways. First, after an encrypted file was auto-closed, when you subsequently restore KeyNote, the program will try to reopen the file automatically and will prompt you for access password. Secondly, if the auto-close is triggered while a dialog box is open, KeyNote will attempt to close this dialog box and continue with closing the file. If the dialog box cannot be closed, the file will not be closed, either. (Both new behaviors can be disabled in Options/Actions.)
* Bug fixed: when no file was open, it was not possible to open a .KNT file by drag-and-drop. This works correctly now.


16 July 2002 - version 1.5.3
* Bugfix: Access Violation error when exporting the last subtree of a tree-type note with the "Current node and subtree" option.
* Selected font color is now used for both active and inactive tabs, the way it should always have been. If you would like to restore the previous behavior, close KeyNote, open the "keynote.ini" file, and in the [TabOptions] section, change ColorAllTabs=1 to ColorAllTabs=0.
* Option to show current wordcount in the statusbar instead of the caret position. (Page count is calculated using "WordsPerPage" setting in [EditorOptions] section, in keynote.ini file. Set to 0 to disable counting pages.)
* Bugfix: the Customize Keyboard dialog box would get clipped on high resolution screen using large fonts. Fixing the bug required making the dialog box non-resizeable, sorry about that.


6 July 2002 - version 1.5.2

* Added: Zoom text in editor (use the drop-down list on the toolbar, or increase/decrease zoom commands under the "View" menu. Double-clicking the drop-down list restores default 100% zoom.)
* Fixed handling directories dropped on KeyNote (KeyNote won't try to import them anymore)
* Fixed export problem if note had "plain text only" setting enabled.
* .LNK shortcuts can again be added to the Favorites panel.
* On the Resource panel, "Find" tab, the list of search results is now color-coded.
* Fixed a bug where a node dragged onto another note would lose its data if the file had not been saved before the dra-and-drop operation.


25 June 2002 - version 1.5.1

* Added: Integration with UltimaShell Autocompletion Server (UAS). UAS is a very interesting application which provides sophisticated autocompletion functions; it even learns new words as you type. Please see http://www.flashpeak.com/ushell/ushell.htm for details. The command to activate UAS is located under the "Tools" menu. WARNING: UAS defines several default hotkeys, some of which will conflict with KeyNote's keyboard shortcuts. You may want to change the UAS hotkeys to suit your preferences and avoid conflicts. (Direct download link for UAS is http://flashpeak.51.net/files/uas.exe, but please do see the website referenced above for information and instructions.)
* Added full paragraph justification - something I didn't think was possible, but there it is. I want to thank Mr Ilya Ulyanov of PolySoft (http://polyedit.com), creator of the freeware editor CryptEdit, for kindly explaining how to enable this feature. (Requires version 3 of the riched20.dll.)
* Added "Refresh" command to Favorites menu
* It is now possible to specify program parameters when adding an "External" location (i.e. a program or a document) to Favorites
* Favorites list is saved after every modification.
* Added "Cycle Case" command.
* The Import and Export commands have been moved under the "File" menu, because "Tools" is getting too long.
* Fixed a resizing problem with the keyboard configuration dialog box.
* Updated the Palm Export plugin (minor configuration fix)


10 June 2002 - version 1.5

* Added ability to customize keyboard shortcuts (for main menu and tree menu commands). See the "Customizing keybaord shortcuts" topic in the Help file.
* Significantly improved the Export function. It is now possible, for instance, to export the whole tree into a single RTF or HTML file. Note: I have done all I could in this respect, in the current edition of KeyNote. Whatever is missing, must now wait for KeyNote 2.0. Please do not ask for any more improvements in the Export feature in the current version of KeyNote.
* It is now possible to create virtual nodes linked to files on removable media (diskettes, CD-ROMs, etc.).
* If no file is loaded at program startup, KeyNote used to automatically create a new blank file. This is now optional, and can be disabled in Options dialog box, "KeyNote files" section.
* Added ability to change font for each individual tree node: select a node, then pick a font from the Font list on the toolbar. (Changing font size will not be possible, alas; the tree doesn't handle differently-sized nodes very well.)
* Since Alt+Left and Alt+Right keys are now used for history navigation, their old function was moved to Shift+Alt+Left and Shift+Alt+Right. Alt+Up and Alt+Down function as before (and these may also be used with Shift, although it is not necessary.)
* Shift+F10 opens context menu in rtf editor, tree panel and scratchpad
* New command: Paste node name from currently selected text
* Added option to disable the Insert key in editor (prevent entering Overwrite mode). It can only be set by manually editing the keynote.ini file: in [EditorOptions] section, set DisableInsKey to 1.
* Added option to select the type of note (simple or tree) which is automatically created with each new file. By default, a tree-type note is created. It can only be set by manually editing the keynote.ini file: in [KeyOptions] section, set StartNoteType to 0 if you want KeyNote to start with a simple RTF note. Value 1 will start with a tree type note.
* Added SleepTime configuration option to [Clipboard capture] section in keynote.ini. This value determines how long KeyNote will remain dormant (and ignore any subsequent clipboard captures) immediately after performing a capture. This value represents duration in 1/10s of a second, i.e. 5 = half a second (default), 10 = one second, etc. You can try increasing this value if KeyNote captures copied text more than once. This setting can only be changed by manually editing the keynote.ini file.
* Added RemovableMediaVNodes option to [TreeOptions] section in keynote.ini. This is an integer option and can take one of the following three values: 0, 1, or 2. This setting controls whether virtual nodes can be linked to files on removable media (floppy disks, CD-ROMs, ZIP drives, etc). If this is set to 0, KeyNote will refuse an attempt to create a virtual node pointing to a file on removable media. If set to 1, KeyNote will allow virtual nodes on removable media, but will display a confirmation warning (default). If set to 2, KeyNote will allow virtual nodes on removable media transparently, i.e. no warning will be displayed. Note that changing this setting will not affect already existing virtual nodes which are linked to files on removable media, i.e. if you set it to 0 (deny), existing virtual nodes linked to files on removable media will remain unchanged. This setting can only be changed by manually editing the keynote.ini file.
* Updated FuncKey plugin to make it easier to use. The plugin still works, and assignments made through the plugin will override the menu command shortcuts (even when these shortcuts have been customized).
* Added "Paste as text" (paste text without formatting) command to the Scratchpad's right-click menu
* Bugfix: KeyNote could not open read-only encrypted files.
* Bugfix: It was possible to attempt to import a binary file into KeyNote (e.g. an .exe or an .mp3 file), because KeyNote did not perform a sufficient file type check. This could lead to the corruption of the binary file (e.g. if the file was imported as a virtual node).
* Bugfix: Using the "Replace" command could throw KeyNote into an infinite loop (e.g. if replacing "the" with "and the").
* Bugfix: In Outline Numbering function, numbering was incorrect when the "Replace node names with numbers" option was used.
* An error message is now displayed when exporting to HTML, if the html32.cnv library cannot be loaded.
* Fixed bug introduced in version 1.4, where newly created tree-type notes did not show checkboxes or images until toggled manually.

-----------------------------------------------------------

12 March 2002 - version 1.4

(Version 1.3.7 had a bug that would cause an access violation error if the "Restore caret position" option was enabled. Version 1.4 fixes that problem.)

* Added history navigation to tree notes. Each note has its own navigation history. Press Alt+Left arrow to move back, or Alt+Right arrow to move forward in history.  These commands are also available from the "Tree" menu and as buttons on the Tree toolbar. Each note holds a maximum of 100 history items; when the limit is exceeded, the oldest items are deleted.

* Added new paragraph formatting property: Numbered list. This is only available if version 3 of the riched20.dll is installed on your system (KeyNote automatically detects it). Click the drop-down arrow next to the "Numbers" button on the toolbar to select the list style: Arabic numbers, letters, Roman numerals. (Shortcut: Shift+Ctrl+E; "Send note by email" now moved to Shift+Ctrl+Alt+E, sorry!)

* Toolbars are now configurable via the "toolbar.ini" file. For a detailed description of how to customize toolbars in KeyNote, please see the "Customizing the toolbars" topic in the Help file.

* Some menu items have been rearranged to make them easier to access (there aren't any third-level nested submenus anymore).

* Added Resource Panel button to the main toolbar. Clicking the button shows or hides the Resource panel. Clicking the arrow next to the button displays the Resource panel context menu.

* Several other buttons added to the toolbars.

* Added ability to use custom icons for tree nodes. This is a toggle: KeyNote will display either the standard node images, or custom images. To pick a custom image, make sure "Custom tree images" in the View menu is checked, then right-click a node and select the "Custom Image..." command. Nodes and tabs share the same set of images. (Tip: you can have a separate set of icons for each .KNT file you create.)

* Added ability to assign any color to a tree node (previously, you could only select from a list of basic colors). To use this feature, click the tree node and then either click the "Color" button on the toolbar, or right-click the tree node, click "Color..." and then click the "Node text" command. (The old list of colors in the menu has been removed.)

* Added ability to assign a background color (highlight) for each individual tree node. To use this feature, click the tree node and then either click the "Background color" button on the toolbar, or right-click the tree node, click "Color..." and then click the "Node background" command.

* The "Bold" property of tree nodes can now also be toggled by clicking the "Bold" button on the toolbar.

* Glossary expansion function now supports \n and \t metacharacters. "\n" is replaced with a line break, and "\t" is replaced with a tab. For example, a string "one\ntwo" will be displayed as
one
two

* Fixed display bug where the Find drop-down combo on the resource panel was too long when Resource panel tabs were right- or left-aligned.

* KeyNote can now be upgraded without downloading the full installer. Instead, you may only download the minimum set of required files and unzip them into KeyNote's directory. This should only be done if you have a previous version of KeyNote properly installed. You must download the full package if KeyNote is not yet installed on your computer. The upgrade package URL is:
http://groups.yahoo.com/group/general-frenetics/files/keynote_upd.zip

-----------------------------------------------------------

5 March 2002 - version 1.3.6
One major new feature and lots ot fixes:

* New: ability to add numbers to nodes in a tree, as in an outline (Tree menu -> Outline numbering...). A dialog box is displayed with several options. Important: nodes are NOT re-numbered automatically; if you have added, deleted or moved nodes, you'll need to use the command again. If you are renumbering a tree that has previously been numbered, make sure to use the correct selection in "Current numbering state" box. If only some of the nodes have numbers and others do not, you MUST select the "Auto detect existing nide numbering" option, which is preselected as default.

* Fixed a bug which would cause an access violation error when deleting the last remaining node in a tree.

* Fixed a bug with clipboard capture, whereby the "Ignore when KeyNote is active" option was not honored.

* Replace operation was permitted even when note was set to Read-Only.

* It is now again possible to change the wordwrap setting in Scratchpad - press Ctrl+W. (The regular edit commands only apply to the active note; they do not affect the Scratchpad)

* Only the "Find" dialog box is affected by the "auto-hide" option; the Replace dialog must be closed manually. (Otherwise, the Replace dialog would hide itself after the first replacement operation.)

* At least one tab in the Resource panel must remain visible; KeyNote will not let you hide a tab if it's the only one visible. (Before, it was possible to hide all the tabs, but then there was no way to restore them, because the context menu could not be activated.)

* With "Paste Into New Node", the pasted text is also used to name the new node.

* Fixed a bug which caused an access violation error in the Glossary editor dialog box when the "Edit" button was clicked with no item selected.

* Windows shortcuts (.LNK files) may now be added to the Favorites panel.

* Fixed a bug which would cause KeyNote to crash on some systems if node names were too long (files with such long node names could be created by the KNTConvert program). KeyNote will now enforce the maximum node name length, 255 characters.

* The "Restore caret position" option was not properly implemented for tree nodes; it will work correctly now.

* Drop-down lists in comboboxes in the main window are now longer, so that it is easier to select font name or size). The lists and default to 16 items (twice as many as before). This value cannot be modified inside KeyNote, but if you want to have still larger or smaller combos, change the "DropDownCount" value in keynote.ini file.

* When creating a new note, the program now defaults to the tree-type note. After that, the last selected note type is remembered across program sesions.

* The text statistics dialog box no longer copies information to clipboard automatically. Click OK to copy, or click Cancel to close the dialog box without copying the information to clipboard.

-----------------------------------------------------------

6 February 2002 - version 1.3.5
* Extended Favorites on the Resource panel to include ability to launch programs and documents (right-click the Favorites list and select the "Add external" command).
* Tree-type notes can now also be used for clipboard capture (each new chunk of text copied to clipboard will be pasted in a newly created node, or into whichever node is currently selected in the tree - configurable in the Options dialog box, "Clipboard capture" tab).
* Taskbar icon: current filename is now displayed first, so that mutliple instances can be differentiated more easily.
* In Options dialog box, "Tree panel" tab, there is a new option which controls how tree notes look after opening a file. There are five possible settings: Show tree fully collapsed, Expand only the node that was last active, Expand only top-level nodes, Show nodes expanded or collapsed the way they were when the file was last saved (i.e., exactly restore the tree state), and Show tree fully expanded. This option supplants the earlier "Auto-expand tree" and "Restore last active node" options.
* In File Properties (Alt+Enter), "Settings" tab, an option was added to override the multiple backup configuration. If you check this option, only 1 backup of the file will be made, even if you specified a higher backup level in Options dialog box. (This is primarily useful for those who have created very large KNT files and don't want to waste disk space by keeping many backup versions of such files, but still want multiple backups for other files.)
* Under the "Edit" menu, "Paste other", a command was added to paste text into a new node in the tree: "Paste into new tree node".
* New "Autorun" macro which is executed when a new node is added to the tree. The macro file must be named "_AutoNewNode.knm", and it will only be executed when a new tree node is created manually. It will NOT be executed when nodes are created through importing files, pasting text, etc.
* If you drag and drop a macro or a plugin file on KeyNote, the macro or plugin will be executed.
* Fixed the broken "Tip of the Day" display when KeyNote starts up in maximized state.
* Comma is now allowed as decimal symbol for expression evaluation.

-----------------------------------------------------------

30 January 2002 - version 1.3.4
* Double-clicking the status bar will show or hide the Resource panel. This is by far the easiest/quickest method to show the Resource panel (unless you prefer to simply press F9).
* New "Favorites" tab added to the Resource Panel. It works similarly to the common "Favorites" function in Internet Explorer and other modern Windows applications. It allows you to store links to commonly used notes or KeyNote files. Double-clicking a Favorite item (or pressing Enter) will jump to the location. (Reminder: If you feel there are too many tabs on the resource panel, you can selectively turn off the tabs you don't use, by right-clicking the tabs and unchecking names of the tabs you want to hide.)
* Added simple HTML export option to the "Export" dialog box and the "Export" command in the tree context menu. (This function usees the native Windows HTML converter, "HTML32.cnv".)
* Improvements in virtual node handling:
  - Separate "Unlink" command on the tree context menu:
    unlinking a virtual node removes the association between
    the node and the file on disk. (The file on disk remains
    unchanged, and the node retains its text, but it will no
    longer be a virtual node)
  - Two new operations are possible when selecting the "Virtual Node'
    command in the tree context menu. Previously, if the node was
    already a virtual node or if the node contained some text, the
    operation was not allowed. Now, if the node is already a virtual
    node, KeyNote allows you to change the file with which the
    virtual node is linked (after a prompt). If the current node
    is NOT a virtual node, KeyNote gives you an option to MAKE IT
    virtual, by "flushing" its data to a file on disk (KeyNote will
    prompt you for a filename where the text will be stored).
* New command: Tree menu -> "Create node from selection" (Alt+F11). This command creates a new tree node from the text selected in the current note. The original text is not deleted, but it remains selected, so you can just press DEL to delete it.
* New command: Tree context menu -> "Add Sibling" (Ctrl+Enter). This command creates a new tree node immediately after the current node in the tree.
* Added more keyboard shortcuts to tree context menu (see "keyboard.txt" for details).
* Bugfix: when adding a template with the same name as an already existing template, the exising template was not removed from the list in the Resource panel.
* In the Options dialog box, "Confirmations" tab, you can now select whether KeyNote should prompt you when you drag and drop nodes onto another tab, and whether the original node (or subtree) should be removed after it has been dropped in the new location. Also, if you hold down the Shift key when dropping the subtree on another tab, KeyNote will move the subtree rather then copying it.
* The Calendar plugin has been improved: you can download the latest version from http://www.lodz.pdi.net/~eristic/free/kn_calendar.zip
* When importing files by drag-and-drop, the editor does not update itself between one file and another, which greatly speeds up the import process.

-----------------------------------------------------------

12 January 2002 - version 1.3.3
* Minor fixes
* Released a separate program, <B>kntconvert.exe</B>, to convert free-format plain text files or email and news archive files to KeyNote tree-type notes. The program contains full documentation. (Requires KeyNote 1.3 or later)
* If you use the Keyboard customization plugin, you can now also assign function keys to templates. You will need to download the latest version of the plugin from http://www.lodz.pdi.net/~eristic/free/kn_funckey.zip
* When searching for "all words" or "any word", you can now mark phrases by enclosing them in double quotes.


-----------------------------------------------------------

2 January 2002 - version 1.3
* The "Find All" command now includes a "Search type" setting. You can now perform an ordinary search ("Exact phrase") or search for notes containing ALL or ANY words entered as the search pattern. In effect, this introduces a simple "AND" / "OR" boolean searches. Note that when you perform a "All the words" or "Any of the words" search, the search results will only include the note and tree node, and will not jump to occurrences of the words within the text of the note. Unlike with the "Exact search" options, if a note contains multiple matches, it will only be listed once in the search results.

* The "Find All" command on the resource panel has been extended to include the abvility to search for text in names of tree nodes ("Exact phrase" search type only).

* After you have used the "Find All" command, right-click the search results list for a context menu. The menu contains commands to insert the search results as clickable hyperlinks in current note.

* Files linked to "virtual nodes" are now backed up when the .KNT file is saved. Virtual node files are always backed up in the original files' directories, and only one backup file is maintained (i.e. the "Backup level" option does not apply to backed up virtual node files).

* When you delete a tree node that has child nodes below it, you now have the option to delete the selected node only while retaining the child nodes.

* Option to display full tree node path in the status bar (Options dialog box, Tree panel settings, "Show full node path in status bar").

* Option to inherit certain tree node properties when creating a new node (Options, Tree panel settings, "Inherit properties from active node").

* The tree panel context menu now includes commands to copy the full path of a node to clipboard and to insert it in current note.

* Some keyboard shortcuts have been added to the tree panel context menu.

* Notes now have a "Plain text" property (Note Properties dialog box, "Advanced" tab). Notes marked as plain text will be stripped of all text formatting while the file is being saved. (You can still apply formatting attributes to such notes, but they will not be preserved when you save and reopen the file). For tree-type notes, the plain text property applies to all nodes in the tree. (This property is not very much useful in itself, but it is needed for a new KeyNote file conversion utility that is under development and will be released soon.)

* For debugging purposes, version number of the riched20.dll library which KeyNote uses is now displayed in the "About KeyNote" dialog box. Please include this information when reporting any problems with the program.

-----------------------------------------------------------

22 December 2001 - version 1.2
MAJOR update thie time!

* The first addition you will notice when you install the new version of KeyNote is the new "resource panel". Press F9 to hide it, press F9 again to re-display it. The resource panel contains several tabs (use Alt+PageUp, Alt+PageDown to switch) which group some of the old features and adds a few of its own. The tabs are: "Find", "Scratch", "Macro", "Plugin" and "Template". Here's a brief description of the resource panel tabs:
	- Find tab: searches notes for text and displays all matches in a convenient list. Press Enter or double-click an item to jump to the matching text. (The old "Find" dialog box remains and works as before.)
	- Scratch tab: a simple RTF scratchpad, automatically loaded and saved. You can easily drag and drop text from notes to the scratchpad and back.
	- Macro: displays all KeyNote macros you have created or installed. Press Enter or double-click a macro to execute it. The Macro toolbar has been moved here, and it cannot be placed anywhere else. A red icon next to a macro indicates an "Auto-run" macro; a blue icon indicates a normal macro.
	- Plugin: displays all KeyNote plugins you have installed. Press Enter or double-click a plugin to execute it. There is a new, small toolbar here with the basic commands. (The old "Select plugin" dialog box has been removed.) A red icon next to a plugin indicates a "resident" plugin (a plugin which can run in the background alongside KeyNote); a blue icon indicates a nonmal, modal plugin (which you have to close to return to KeyNote).
	- Template: displays all templates you have created. Press Enter or double-click a template to insert it in the current note. Press INS to create a new template. A blue "A" icon next to a template indicates a Rich Text template (a template which includes text formatting); a black "A" icon indicates a plain-text template.

Additional tips:
	- All tabs on the resource panel have their own context menu: right-click to display it. The menus offer additional commands not present elsewhere.
	- Right-click the tabs themselves to display a menu of options related to the resource panel. You can place the resource panel to the left or to the right of the notes window; you can arrange the tabs in four different ways, and you can even hide individual tabs.
	- If you add a macro or a template while KeyNote is running, you do not need to restart KeyNote to display the new item. Just press F9 twice; the resource panel will be hidden and then re-displayed, and the list of macros or templates will be refreshed.
	- To add a plugin while KeyNote is running, right-click the PLugin tab and select the "Reload Plugins" command from the context-menu. The list of plugins is relatively slow to initialize, so it is not re-read automatically.

* Another major improvement is the way in which imported files and files you drop on KeyNote's window are handled. In both cases, the same dialog box is now displayed, which allows you to choose an action to be performed on the selected files. One significant addition here is that you can now import files as tree nodes (before it was only possible to import files as virtual nodes).

* You can now import HTML documents and have them automatically converted to RTF. Note, however, that this is a pretty experimental feature. KeyNote uses MS Office or MS Internet Explorer to perform the actual conversion, so you will need to have at least one of them installed on your computer. You can choose whether to use Office of Explorer converters (click the "HTML Options" button in the dialog box displayed when you drop or import files). The function works with MS Office 97 or 2000, and with MS Internet Explorer 5.0 or higher. The results of the conversion are nearly identical in both cases. Note, however, that because KeyNote has no internal support for tables, and many HTML documents are formatted using tables, the conversion will not always produce a note that you can easily work with. In such cases, you can use a HTML formatter to strip the tables from the document before importing it into KeyNote. Eventually, I will release a plugin that performs this function.

* All known search-related bugs have been fixed. All three of them!

* You can execute macros and plugins by double-clicking them in Windows Explorer. This requires associating KeyNote with several file extensions. KeyNote does it by default when it is first installed. If you are upgrading, you may have to associate .KNM files (macros) and .KNL files (plugins) with KeyNote manually. (To do so, just double-click a .KNM or .KNL file in Windows Explorer, and select KeyNote when Windows asks you what application you want to open the file with.)
* Added "Run Last Macro" command (Ctrl+F5).
* Double-clicking status bar minimizes KeyNote.
* Splash screen has been removed.
* Note tabs can now be arranged vertically (along the left or right edge of the program window) in addition to being placed at top or bottom.

-----------------------------------------------------------

9 December 2001 - version 1.1
Minor bug fixes and improvements:
* Glossary: on Shift+F7 (Create glossary entry), current word is selected automatically.
* Glossary editor now closes on ESC key.
* Bugs in Font and Font Size drop-down lists have been fixed (it was not possible to select font face or size using keyboard)
* If the SHIFT key is held down when checking a tree node, making it bold or setting its color, the command is also performed for all the node's children (sub-nodes).
* I am beginning to design KeyNote 2.0. If you are interested in what new features and improvements are planned, please see http://keynote.prv.pl

-----------------------------------------------------------

26 November 2001 - version 1.08
Long time without an update. Between versions 1.05 and 1.07, I've moved into a new apartment and changed operating system to Windows 2000. I expect to be able to work on KeyNote some more again.

Note: Version 1.07 had a seriuos bug which affected Windows 95 and Windows 98 users. That version was pulled from the website immediately after the bug was discovered. Version 1.08 fixes that bug, but it does not introduce any new functionality over version 1.07.

* Drag and drop files: When you drop a file anywhere on KeyNote's main window (except the editor area), KeyNote will now display a dialog box which lets you select an action to perform on the file(s) you have dropped. For instance, you can import the file, create a virtual node, or insert a hyperlink to the dropped file. The dialog box only displays actions which are possible for the ype of the dropped file (e.g. .KNT files can be opened or merged, but not imported; .TXT and .RTF files can be imported but not merged, etc.)
* Spellchecker (under the "Note" menu). Requires MS Word 97 or 2000 (tested only with MS Word 2000). This is a very experimental module, please treat it as beta and feel free to report any problems.
* Ability to specify note language. (This is required for the spellchecker to function properly. You can select default language for new notes, or select text in an existing note and set its language, so that the spellchecker can select proper dictionary.)
* New node-related features (for tree-type notes):
  - Checkboxes (can be shown or hidden via the View menu)
    (Keyboard shortcut: Ctrl+` in tree panel)
  - Bold (each node can be displayed with bold or normal font)
    (Keyboard shortcut: Ctrl+B in tree panel)
  - Color (you can select the color used to display each node)
  All these features are only accessible via the tree panel
  right-click menu.
* Menu command added (under "View") to hide or show the tree panel in tree-type notes. Keyboard shortcut: Shift+F11.
* Added data safety: When saving a file, KeyNote writes data to a temporary
file (with the ".tmp" extension), and only rewrites the original file if the save process has been successful.
* More data safety: KeyNote can now maintain up to 9 most recent versions of your files. This is called "Backup level" and is configurable in the Options dialog box, on the new "Backup options" tab. For instance, if you choose backup level 3, KeyNote will keep up to three most recent versions of your file, with the following extensions: ".bak", ".bak2", and "bak3". The oldest file is the one with the highest number. When you save your file again, the ".bak3" (oldest) file will be discarded, the ".bak2" file will be renamed to ".bak3", and the ".bak" file will be renamed to ".bak2". Note that if you initially set a high backup level and subsequently choose a lower level, old backup files may remain on your disk and will have to be deleted manually. (For instance, if you start with backup level 9 and then reduce the level to 3, there will be old backup files remaining, with extensions ".bak4" to ".bak9". KeyNote will not automatically delete these files.)
* You can now specify a separate directory where all backup files will be kept. By default, each backup file is created in the same directory in which the original (.KNT) file resides. If you want, you can select a special directory where ALL backup files will be placed (e.g. the TEMP directory on your disk). This makes it easier to clean up old backups periodically.
* Bug fixed: There was a problem setting left paragraph indent using the "Paragraph" dialog box.
* Bug fixed: There was a problem pasting paragraph attributes (after the "Copy paragraph attributes" command was used).
* When you copy font attributes or paragraph attributes, the copied information now persists across file sessions, i.e. you can open a different file and paste attributes copied from the previous file (that is now closed).
* When you create a new file and have the AutoSave feature turned on, KeyNote prompts you to save the file, because AutoSave cannot work until the file has been given a name. An option has now been added to skip the prompt.

-----------------------------------------------------------

11 August 2001 - version 1.05
* The "merge" function now prompts for passphrase if file is encrypted
* Small plugin technology fix
* confirmation of "Refresh" command for virtual nodes is now optional
* option: Ignore (do not delete) protected text
* virtual nodes are now also saved if the referenced file does not exist (but the node was initially loaded correctly)
* support for TreePad shareware RTF-formatted files (import/export)
* automatically disable folder monitor if file resides on a read-only medium or on a network drive

-----------------------------------------------------------

18 July 2001
* Minor fixes
* Version 1.03

-----------------------------------------------------------

7 July 2001
* Calculator added to "Tools" menu
* Templates (rich text or plain text), under the "Tools" menu
* Minor fixes
* Version 1.02

-----------------------------------------------------------

30 June 2001:
Version 1.0 is finally here! Enjoy.
* KeyNote is becoming an Open-Source project. You can download full source code, distributed under the Mozilla Public License. See Help file and "license.txt" for details. More information is forthcoming.
* Completely redesigned the "Options" dialog box, for accessibility and ease of use.
* fixed bug whereby the "Allow auto-run macros" option was not always honored if turned off
* added "System" button to "File properties" dialog box. It displays the Windows built-in "File properties" dialog box for the currently open file.
* Option: "Enable Rich Edit version 3.0 fixes" - now completely removes the "disappearing font styles" bug some users experience with version 3.0 of Microsoft's riched20.dll standard library. See file "bugs.txt" for details. This option is disabled by default on Windows 95 systems, and enabled by default on Windows 98, NT and 2000 systems.
* The old text files (documentation) have now been replaced by standard WIndows Help file. The Help is not yet complete and has a lot of blank spots; these will be filled in shortly.
* Version 1.01

-----------------------------------------------------------

22 June 2001
This is probably the last release of KeyNote before version 1.0. Sorry it took so long, but there's quite a lot of new functionality this time.
* Ability to create MACROS (remembered sequences of key presses and commands). See file "macros.txt" for details.
* Support for PLUGINS. A few sample plugins are installed with KeyNote; more can be downloaded from the program homepage. Please see the file "plugins.txt" for details.
* File manager and Glossary editor dialog boxes are now resizeable
* Activation hotkey can be changed or enabled without restarting KeyNote
* In "Go to line number" dialog box, you can not only enter line numbers, but also increment values, e.g. "+5" to go 5 lines forward or "-5" to go 5 lines back.
* Ctrl+H (Highlight color) and Ctrl+R (Font color) commands now behave in the same way, for consistency. By default, each command simply applies the color currently visible on one of the two color selection buttons on the toolbar. In Options dialog box ("Advanced" tab) you can change this behavior, so that these commands will display the old-style color selection dialog boxes. This isn't as fast, but allows for selecting font and highlight colors without using the mouse.
* Shift+F10 no longer hides/shows tree panel in a tree note. This keyboard shortcut is used by Windows to display context menu. Use Shift+F1 instead.
* Added "Show all toolbars" and "Hide all toolbars" commands ("View" menu)
* Added a "Safe print" option to the "Advanced" tab in Options dialog box. Try this setting if you encounter problems with printing notes.
* Tree structure can now be saved to a text file ("Tree" menu)
* Style list is saved only if styles have been modified
* BUGS FIXED:
	- The "Match bracket" function now works with angle brackets too
	- "Save and restore caret position" now works correctly with tree-type notes too
	- Multiple pasting error with "Clipboard Capture" function
	- "Repeat Last Command" logic improved
	- Searchng a tree note for text now finds nodes above the currently selected node if the "Search all nodes" option is enabled
* Version 0.999

-----------------------------------------------------------

21 May 2001
* Bugfix release
* Old drag-and-drop behavior is restored now. Unfortunately, because the RichEdit control now embeds any object dropped on it, you can no longer open or import files by dropping them on the editor. However, you can import or merge files by dropping them ANYWHERE ELSE on the main program window. (You can still create virtual nodes by dropping a file on the tree.)
* Version 0.992

-----------------------------------------------------------

17 May 2001
* You can now specify a custom icon for each .KNT file. This icon will be displayed in the system tray. The feature is useful if you run several instances of KeyNote at the same time, as it allows you to quickly identify the file which is loaded in each running instance of KeyNote. To specify a custom icon, open the File Properties dialog box ("File" menu), click the "File icons" tab, then make sure the "Use custom Tray icon for this file" checkbox is checked, and select an icon in the text field below.
* You can now have a different custom set of tab images (.icn file) for each KeyNote file. You can also specify that a particular file should only use the built-in set of tab images (useful when sharing the file with someone who may have a different set of customized tab images). To specify these settings, open the File Properties dialog box ("File" menu), click the "File icons" tab, then make sure the "Show icon images on tabs" checkbox is checked, and select your preference by clicking one of the radio buttons. The "Default" setting will use the standard (possibly customized by you) set of tab images, stored in the file "keynote.icn". The "Built in" setting will ensure that the file always uses the "factory default" images (always the same; you will not be able to customize tab images when this option is selected for a particular file). The "Other" setting allows you to choose an alternate .icn file. To create a new .icn file, specify a name of a non-existing file in the edit box and the file will be created when you close the "File Properties" dialog box.
* Fixed bugs in Find and Paste commands
* Version 0.99

-----------------------------------------------------------

15 May 2001
* Added ability to insert hyperlinks to locations inside KeyNote file (notes and tree nodes). This is a big topic, please see the file "linking.txt" for detailed explanation of this feature.
* Added the "Replace" command.
* The "Find" dialog box is now non-modal.
* If the file you are opening has a read-only attribute, it is opened in read-only mode.
* Version 0.985

-----------------------------------------------------------

12 May 2001
* Many changes this time. Some menu commands were moved to other locations.
* Please review the file "KEYBOARD.TXT" installed in the \doc subdirectory, it contains a complete, updated list of all keyboard shortcuts for KeyNote, including special/alternate behaviors with Shift or Ctrl keys.
* The bug list has been updated.
* The spin control on the Formatting toolbar used to specify font size was replaced with a drop-down list, such as used in Word and WordPad. This seems to be more convenient, because you can quickly pick one of the predefined font sizes.
* Added a Paragraph Properties dialog box to specify all supported paragraph properties.
* Images and objects can now be inserted into note text. The relevant menu commands are located under the new "Insert" menu. Note that you can also insert images by pasting them from clipboard. Bitmap and GIF formats are supported. (I tried adding support for JPEG images, but this requires including a library that increases the size of the program by 100 kb! It's just not worth such a bloat.)

WARNING!! Inserting a picture or an object increases the size of the KeyNote file enormously. A small picture can add a full megabyte to the file size. This is due to the RTF format and the way in which such data is stored, there is no way around it. A KeyNote file containing pictures or objects will be huge and take considerable time to open and save. On the other hand, you can now insert and edit an MS Excel spreadsheet directly in KeyNote :-)

* Added a "Paste Special" dialog box.
* You can now start the WordWeb thesaurus with a keyboard shortcut: Ctrl+F11.
* You can insert contents of a disk file into a note (text and RTF files only).
* You can insert an URL-style link to a file on disk. Such a link takes the form of "file:///c:\documents\file.txt". The link can point to a document or an executable program.
* Added several advanced commands to the Options dialog box.
* You can hide a tree panel in a tree-type note by pressing Shift+F1.
* Added a Glossary editor which allows you to add, edit and remove glossary expansion terms from inside KeyNote.
* Added "Visit website" and "Email author" commands to the Help menu.
* Added a "Refresh" command to the tree context menu. This command is only available for virtual nodes. If a file which is attached to a virtual node has changed (e.g. it was edited in another application), you can use the Refresh command to update the contents of the file in the virtual node.
* In the Find dialog box you can now select whether all nodes should be search in a tree-type note, or only the current node.
* Version 0.98

-----------------------------------------------------------

14 April 2001
* Bugfix release
* Version 0.975

-----------------------------------------------------------

12 April 2001
* Simple text statistics (under the "Tools" menu)
* Superscript/Subscript commands are now separate.
* If no text is selected, the "Evaluate expression" command takes the whole current line as source expression. A trailing '=' sign, if present, is ignored.
* Improved word selection logic (for WordWeb, Find and Glossary expansion) In editor, press Alt+W to select the current word.
* Added command names for "Repeat last command".
* Added rudimentary support for bookmarks, but don't expect too much. The RTF editor doesn't support them in any way, so it's just a stopgap measure, and not too effective. You can have up to 10 bookmarks for the whole file. To set a bookmark, press Alt+Shift+<digit> (0 through 9). To jump to an existing bookmark, press Alt+<digit>. The bookmarks do not move with the text, which limits their usefulness quite heavily, but there is simply no workaround for this. The bookmarks are not persistent, i.e. KeyNote forgets them when you close the file. The bookmarks are also not visible, because the RTF control doesn't have a gutter area where they would be displayed. Except for persistent bookmarks, there will be NO improvement in this area; please don't ask, because it can't be done (or, more to the point, I cannot do it).
* Version 0.974

-----------------------------------------------------------

7 April 2001
* New editing commands:
	+ Compress white space (adjacent spaces and/or tabs)
	+ Trim blanks at end of lines (left, right, both)
	+ Invert case ("This" to "tHIS"; Shift+Ctrl+I)
* New function: Insert special character (select from a dialog box)
* New function: Match bracket (Ctrl+M)
* It is now possible to export a single node in a tree. This is done via the "Export" command in the tree context menu (right-click), not via the "Tools|Export" command.
* KeyNote now uses a different way of detecting previous instance and communicating with it. The bug here which affected Windows NT systems should not be occurring anymore - please let me know, because I have no way of testing this.
* KeyNote can optionally play a sound (a wave file) when capturing text from clipboard. KeyNote will play the file called "clip.wav" included with the program. You can replace this file with any other wave sound which you prefer to use.
* Version 0.973

-----------------------------------------------------------

30 March 2001
* The most requested feature is now ready: you can copy tree nodes (subtrees) from one note to another, or even between different files. Please see the file "tree.txt" for details on how to do this.
* Added "Glossary term expansion" feature. The glossary is a set of word pairs, stored in the file "keynote.exp". When you press F7, KeyNote checks if the word at the insertion point (caret) exists in the glossary; if it does, then KeyNote replaces the current word with the other word in the pair. This is very useful to enter the hard-to-type characters: for instance, "cc" (without the quotes) will expand to the copyright symbol; "rr" to the registered trademark symbol, and "tm" to the trademark symbol. You can add new word pairs to the glossary by pressing Shift+F7. The whole glossary is stored in the file "keynote.exp", which is a plain text file and may be edited in any text editor (or in KeyNote's virtual node, but make sure to turn WordWrap OFF for that.)
* Ctrl+H now applies the last highlight color used, rather than opening the color selector dialog box.
* Version 0.972

-----------------------------------------------------------

30 March 2001
* Tree notes can now have a vertical layout (the tree panel placed above the editor, rather than to the left of it). This is configurable through Note Properties (F4).
* Text font and highlight colors can now be set via the supercool Office-like buttons on the toolbar - more conveniently than through the standard color selection dialog box. (You can even customize the non-standard colors via a mouse right-click!) Note, however, that the Background Color button is no longer available, because three identical color buttons on the toolbar is a bit too much. Sorry about that. I hope this is not a big issue, since changing the BG color is not nearly as frequent as changing the font or highlight color. You can still change the background color via the Ctrl+D shortcut ("Format" menu).
* Fixed the bugs which caused imported trees to lose the background color.
* Grey '*' on the numeric keypad no longer switches between editor and tree (you can use it in the editor again)
* Shift+TAB now switches focus from editor to tree. (Use TAB to switch focus from tree back to editor).
* Now you REALLY cannot edit note properties if the note is Read-Only (there was a bug that caused the read-only status of a note to be ignored)
* Version 0.971 (not enough changes for 0.98? :-)

-----------------------------------------------------------

28 March 2001

* New feature: Ability to highlight text in editor. This is also supported by the styles (i.e. highlighting can be part of a style definition)
* KeyNote can now display the current font and/or paragraph properties in the status bar. This feature is off by default, because it slows down the program; you can turn it on using the options under the "View" menu.
* More editing commands; all editing commands now have keyboard shortcuts
* When opening an encrypted file, you now have an opportunity to re-enter the access passphrase if it was entered incorrectly the first time.
* Version 0.97 Beta D

-----------------------------------------------------------

27 March 2001
* Two serious bugs fixed:
    - no more problems with opening a file that contains empty tree notes
    - fixed problem that would result in a crash when the "clipboard capture" was switched from one note to another several times, consecutively
* The note which is designated for clipboard capture is now marked with a different tab color, which makes it more visible
* Toolbars can now also be docked at the bottom of the main window (suggestion: place the Style and Tree toolbars there)
* Double-clicking a tab now opens the "Rename note" dialog box (or the "Note Properties" dialog box is Shift is held down)
* Version 0.97 Beta B

-----------------------------------------------------------

21 March 2001
* Began preparation for releasing KeyNote as Open Source. More information will follow.
* Fixed a font style bug that a few users have reported and I was too stupid to find. The Bold, Italics, Underline buttons would sometimes "not work". Now they do.
* Nice new feature: Styles. You can now define a style based on the current text properties in a note, and reuse the style later. Styles are saved in a file called "keynote.kns".
* Added ability to open URL in a new browser window.
* Added configuration option to choose the default behavior when an URL is clicked: Open, Open in new browser window, Copy to clipboard, Both open and copy, Prompt user (show dialog box).
* Added ability to:
	- automatically minimize KeyNote after X minutes of inactivity
	- automatically close file after X minutes of inactivity. This adds a thin level of extra protection for your encrypted files. Note, however, that the file will NOT be auto-closed if any dialog box is open.
* Nice new feature: Repeat last command (Ctrl+/). Most (but not all) edit commands can be repeated across notes. For example, if you use the Font dialog box to select a font style, you can then switch to another note, press Ctrl+/ and the same font style will be applied here.
* Added support for font styles:
	- "disabled" font style
	- subscript and superscript
* Added support for paragraph styles:
	- full indentation support (left, right, first line)
	- line spacing (single, one and a half, double)
	- space before, space after paragraph
* New command: Reverse string ("ABC" becomes "CBA")
* A few settings which already existed but were not configurable inside the program have been added to the Options dialog box.
* Rearranged Edit menu items; changed some keyboard shortcuts.
* Version 0.96 Beta

-----------------------------------------------------------

19 March 2001
* Much improved support for drag-and-drop operations:
  - If you drag and drop a KeyNote file onto the main program window, the file will be opened. If you hold down the Shift key when dropping the file, the Merge function will be executed instead, allowing you to selectively add notes from an external KeyNote file.
  - If you drag and drop one or more RTF or text files onto the editor, the file(s) will be imported. (Same as Tools, Import)
  - If you drag and drop one or more RTF or text files onto the tree, the files will be linked as Virtual Nodes in the tree.
  All these operations can be canceled.
* Version 0.95 Beta

-----------------------------------------------------------

18 March 2001
* The "Find" function works again, and it now supports the
  tree notes.
* Version 0.94 Beta

-----------------------------------------------------------

17 March 2001
* Added function to find a tree node containing text (Shift+Ctrl+F; use Shift+F3 to repeat last "Find node" operation)
* Fixed a bug which made it impossible to export a tree to a single text file (all other export modes were unaffected)
* New global editor option: Auto Indent
* A virtual node can now be reverted to a "normal" node. If you click the "Virtual node" command in the tree context menu on a node that already is virtual, you will be given an option to revert the node to normal. The contents of the linked file will be retained, but the link with the file will be broken, and the text will now be stored in the .KNT file. This, BTW, enables you to import RTF and text files directly into tree nodes, although in a somewhat roundabout way.
* Some interface fixes (menu items names; shortcuts; icons)
* Version 0.93 Beta

-----------------------------------------------------------

12 March 2001
* New feature: "virtual nodes". Add a node to the tree, then right-click the new node and select the "Virtual node" command from the context menu. You will be prompted for a file name. If you select a text or RTF file, the contents of the file will be displayed as the node's text - however, the file will NOT be imported into KeyNote. Instead, you will be editing the actual file ON DISK, and all changes will be saved to the original file. Only the name of the disk file will be stored in the .KNT file. This allows you to use KeyNote for editing file which you want to remain as individual documents on disk.
  - Note 1: If you use encryption, please see "Security considerations" section in the "encrypt.txt" file before using virtual nodes.
  - Note 2: Virtual nodes can only hold files which reside on a local, non-removable drive. That means one of the hard disks in your computer. Files on diskettes, CD-ROM discs or network drives cannot be put in virtual nodes, because they may not be available the next time you open the .KNT file.
  - Note 3: When you delete a virtual node, only the tree item is removed; the actual file on disk is never deleted.
* New feature: Expression evaluation. KeyNote will calculate the result of an arithmetic operation typed in the editor. For instance, you can type "2 + 2" in KeyNote, then select the expression and press Shift+Ctrl+E. The result of the addition will be copied to clipboard and, optionally, inserted into the note. Later, you can paste the result of the last calculation performed by pressing Alt+Insert.
* New feature: In addition to specifying default properties for all new notes you create, you can also specify such defaults for a particular .KNT file. For instance, you may have a file for which you want ALL notes to use white text on a black background; but in all other files you use black text on a white background. The new feature allows you to keep your glbal defaults intact, but define "white on black" just for that one, unique file. To specify that the default properties you set should only be applied to the currently open file, press F6 to display the usual "Defaults" dialog box, set the properties the way you want, and then click the "Advanced" button, and click the "Save as default for <filename.knt>" menu option. If that menu option is checked, the defaults will apply to the current file only; otherwise the defaults will apply to all your KeyNote files, as usual.
* When typing in the editor, you can still move between tree nodes without switching focus to the tree: hold down the ALT key and press one of the direction arrows
* When opening a .KNT file from a removable drive (diskette, CD-ROM, or a network drive) KeyNote will open the file in Read-Only mode. (For diskette and network drives, this is an option, editable by manually editing the INI file)
* You can change the background color of ALL NODES in a tree. To do this, hold down the SHIFT key while you click the "Background color" button on the toolbar.
* If KeyNote was maximized when you closed it, the maximized state will be restored when you restart the program later.
* You can now right-indent paragraphs, in addition to the normal left indentation. Note that indentation command keyboard shortcuts have changed.
* Fixed paragraph indentation bug.
* The "Edit" menu has been rearranged to make it more compact. Some commands have been moved to submenus.
* Fixed bug which prevented users from changing the Time format in Options
* Added two new options: backup file extension and Append backup extension
* Added new option: Automatically paste Expression evaluation results
* Version 0.92 Beta

-----------------------------------------------------------

5 March 2001
* KeyNote has finally earned its name: it is now possible to encrypt notes. Please read the file "encrypt.txt" for details!
* KeyNote now supports tree-type notes. See file "tree.txt" for details.
* The format of the currently loaded file is reflected with a special icon in the status bar (KeyNote file, Encrypted KeyNote file, Dart Notes file, Read-only file; error or no file loaded)
* Fixed a major bug which made it impossible to manually change the file format to the DartNotes format. (Files that were in the DartNotes format originally were saved in this format correctly.)
* KeyNote can now export and import files created by a freeware notebook-type program called TreePad (http://www.treepad.com)
* When importing files, you can now select more than one file in the "Open" dialog box, which allows you to import several files at once
* In the file manager window, files are now correctly sorted when the window is initially opened.
* Version 0.90 Beta

-----------------------------------------------------------

3 March 2001
* When an alternate INI file is suplied on command line, KeyNote adjusts all its other configuration files to use the same path. This means, that just by adding the name of the alternate INI file to the commandline (e.g. in the properties of the shortcut you use to start KeyNote), you can use a completely different, separate set of configuration options, editor defaults, etc. The following files are affected:
  	keynote.ini (main config file)
  	keynote.mgr (file manager information)
  	keynote.mru (form size and position; recently used files list)
  	keynote.icn (user-defined icons)
  	keynote.def (default editor settings)
  	keymail.ini (email configuration)
  	keymail.adr (address list)
  	keymail.sig (signature file)
  This allows KeyNote to be shared by many users on the same computer, with each user having his or her own set of preferences.
* In the Email dialog box, it is now possible to disable the logging feature
* Fixed thjisting note after a note was deleted.
* Fixed thjlose their icon images temporarily.
* Version 0.89 Beta C

-----------------------------------------------------------

26 February 2001
* Added integration with the fantastic freeware Dictionary / Thesaurus program called WordWeb. You will of course need to install WordWeb to use this feature. You can get WordWeb from http://wordweb.co.uk/free You will find deatiled information in the file "wordweb.txt" installed with KeyNote.
* Version 0.89 Beta A

-----------------------------------------------------------

26 February 2001
* Lots of changes this time. This is probably the last release of KeyNote before the new big feature is introduced: nested, tree-like hierarchy of notes. This feature is now in the testing stage.
* IMPORTANT: Program options and Note/Editor settings have been thoroughly rearranged to group them more logically. The main "Options" dialog box now only has options pertaining to the program as such; all editor-related confioguration options have been moved to the "Defaults" dialog box (press F6 and see the "General" tab).
* The Note Properties dialog box now has a tab name history drop-down list (just like the small "New Note" dialog box always had).
* IMPORTANT: The old bug which cause the font properties and background color to be lost on Winows NT and Windows 2000 systems is now gone! (There are still a few related issues there, but nothing fatal. I'm working on these.)
* New function: Ability to merge notes from a .KNT file on disk into the currently open file. See "Tools" menu, "Merge with File"
* When you are upgrading to a newer version of KeyNote, the program will now detect that and, if necessary, display information about the most important changes in the new release.
* The Clipboard Capture options dialog box is gone; all settings related to clipboard capture have been moved to the main "Options" dialog box.
* IMPORTANT! The Clipboard Capture tokens (used to insert current date or time with each captured clip) must now be spelled in UPPERCASE. (Previously, lowercase was required). You will need to update your settings there if you use those tokens.
* It is now possible to turn tab icons on or off for each .KNT file separately. For instance, you may want to keep the icons ON for most of the time, but for one particular file (which has a lot of tabs, for instance) you can turn the tab icons off. To do this, open the File Properties dialog box (Alt+Enter), click the "Settings" tab, and check or uncheck the "Show icons on tabs" checkbox.
* You can now specify that a pearticular .KNT file should always be opened in Read-Only mode. To do this, open the File Properties dialog box (Alt+Enter), click the "Settings" tab, and check or uncheck the "Open [FILE] as Read-Only" checkbox.
* The File Manager window has been improved. It now has an option to display filenames only (without the paths), which makes it easier to select a file by typing the first few letters of its name.
* The Delete Note confirmation dialog box now defaults to No.
* The name of currently open file is displayed on the title bar.
* The state of the WordWrap and other menu items is now updated correctly.
* ...and plenty of other improvements and fixes here and there. Wait till you see the Tree notes!
* Version 0.89 Beta

-----------------------------------------------------------

10 February 2001
* FILE FORMAT CHANGED! Please read the information in the file "readme.txt". You will not lose any of your data, because the new version of KeyNote can open files created with previous versions of the program. However, versions of KeyNote earlier than 0.85 will not be able to open files created by later versions.
* Redone the File Manager; now works much faster and is more convenient.
* The Recent Files Menu (MRU) is now additionally available from the drop-down menu attached to the Open button on the toolbar. It is now easier and faster to access the MRU files list.
* Many internal changes and fixes
* Version 0.85 Beta

-----------------------------------------------------------

26 Jan 2001
* Fixed the problem that caused one or two additional blank pages to be printed with each note
* Changes in Clipboard capture options: You can now have the current date and/or time automatically added as part of the separator line. Include "%D" (no quotes) in the separator for current date, and "%T" for current time. Note that this change requires that the separator be added ABOVE the captured text, instead of below it, as was done originally.
* Misc. small fixes
* Version 0.80 Beta (Versions 0.77-0.79 were not released)

-----------------------------------------------------------

1 Dec 2000
* Bug fixes (note background color was not preserved under certain circtumstances; the keymail.ini file was not updated correctly)
* Added "Show Icons" to "View" menu, to quickly turn the tab icons
  on or off.
* Version 0.76 Beta

-----------------------------------------------------------

28 Nov 2000
* Added ability to sort lines in a note
* Version 0.74 Beta

-----------------------------------------------------------

22 Nov 2000
* Added the ability to add, change and delete icons that are displayed on the note tabs. Hope this works for everyone :)
* Certain keboard shortcuts have been altered (sorry!) to free up all Alt+Letter combinations. This was done so that you can now use Alt+Letter shortcuts to quickly select tabs! When naming or renaming a tab, place the ampersand (&) in front of the letter which you want to use as the ALT hotkey. Then, click Alt+Hotkey letter to immediately switch to this note. For instance, you can switch between notes in this file by pressing ALT+W, ALT+N, ALT+H, ALT+C and ALT+A. Note that the hotkey letters are underlined in the note tab names.
* Insert/Overwrite mode is now reflected in the status bar (INS/OVR)
* Notes can now be sorted alphabetically ("Alphabetize notes" in the "View" menu)
* Added file "cmdline.txt" to the \doc subdirectory.
  The file documents the command-line options KeyNote supports.
* Version 0.73 Beta

-----------------------------------------------------------

20 Nov 2000
* Notes can now be sent via E-mail directly from Keynote (see file "keymail.txt" for detailed help on this feature)
* Added "Clipboard capture" feature (under "Tools" menu)
* Version 0.70 Beta

-----------------------------------------------------------

11 Nov 2000
* Minor cosmetic fixes
* Version 0.68 Beta

-----------------------------------------------------------

9 Nov 2000
* Fixed a bug which caused the note icon to be ignored when you used the "Rename" function. Now you can also change the note icon in the "Rename" dialog box (F2).
* Added command: "Paste into new" (create a new note and paste text
  from clipboard into it)
* Added command: "Copy all" (copy all text in a note and copy to clipboard)
* Version 0.67 Beta

-----------------------------------------------------------

7 Nov 2000:
* basic support for printing (only 1 note at a time)
* Version 0.66 Beta

-----------------------------------------------------------

31 OCT 2000:
* Minor bug fixes
* Settings made in "Export" dialog box are now preserved across sessions
* "Delete line" command is now UNDO-able
* Version 0.65 Beta B

-----------------------------------------------------------
END OF HISTORY FILE
